const app = getApp();
Component({
    /**
     * 组件的一些选项
     */
    options: {
        addGlobalClass: true,
        multipleSlots: true
    },
    /**
     * 组件的对外属性
     */
    properties: {
        bgColor: {
            type: String,
            default: ''
        },
        isBack: {
            type: [Boolean, String],
            default: false
		},
		delta: {
			type: [Number, String],
			default: 1
		},
        isHome: {
            type: [Boolean, String],
            default: false
        },
        isCustom: {
            type: [Boolean, String],
            default: false
        },
        bgImage: {
            type: String,
            default: ''
        },
        customIcon: {
            type: String,
            default: ''
        },
        customText: {
            type: String,
            default: ''
        }
    },
    /**
     * 组件的初始数据
     */
    data: {
        StatusBar: app.globalData.StatusBar,
        CustomBar: app.globalData.CustomBar,
        Custom: app.globalData.Custom
    },
    /**
     * 组件的方法列表
     */
    methods: {
        BackPage() {
            wx.navigateBack({
                delta: this.data.delta
            });
        },
        toHome() {
            wx.reLaunch({
                url: '/pages/index/index',
            });
        },
        TabCustom() {
            var myEventDetail = {
                component: "defaultTitle",
                type: "tabCustom"
            } // detail对象，提供给事件监听函数
            var myEventOption = {} // 触发事件的选项
            this.triggerEvent("myevent", myEventDetail, myEventOption);
        },
    }
})