const app = getApp();

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    bgColor: {
      type: String,
      value: "bg-white"
    },
    color: {
      type: String,
      value: "text-orange"
    },
    align: {
      type: String,
      value: ""
    },
    url: {
      type: String,
      value: ""
    },
    tabCur: {
      type: Number,
      value: 0
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    scrollLeft: 0,
    data: [{
        id: 1,
        name: '分类'
      },
      {
        id: 2,
        name: '品牌'
      }
    ]
  },

  /**
   * 组件的方法列表
   */
  methods: {
    // 选择事件
    TabSelect: function(e) {
      this.setData({
        tabCur: e.currentTarget.dataset.index,
        scrollLeft: (e.currentTarget.dataset.index - 1) * 60
      });

      var myEventDetail = {
        component: "defaultNav",
        data: {
          id: this.data.data[this.data.tabCur].id
        }
      } // detail对象，提供给事件监听函数
      var myEventOption = {} // 触发事件的选项
      this.triggerEvent("myevent", myEventDetail, myEventOption);
    },

    // 加载数据
    LoadData: function() {
      if (app.Validate.Url(this.data.url)) {
        app.Request({
          url: this.data.url,
          method: "post",
          data: {},
          success: res => {
            this.setData({
              data: res.data.data instanceof Array ? res.data.data : []
            });
          },
          fail: res => {
            wx.showToast({
              title: res.errMsg,
              icon: 'none',
              duration: 3000
            });
          }
        });
      }
    }
  },

  /**
   * 在组件布局完成后执行
   */
  ready: function() {
    if (this.data.tabCur > 0){
      this.setData({
        scrollLeft: (this.data.tabCur - 1) * 60
      });
    }
    this.LoadData();
  }
})