const app = getApp();

Component({
	/**
	 * 组件的属性列表
	 */
	properties: {
		bgColor: {
			type: String,
			value: "bg-white"
		},
		color: {
			type: String,
			value: "text-black"
		},
		curBgColor: {
			type: String,
			value: "bg-ghostWhite"
		},
		curColor: {
			type: String,
			value: "text-orange"
		},
		height: {
			type: String,
			value: "100%"
		},
		width: {
			type: String,
			value: "200rpx"
		}
	},

	/**
	 * 组件的初始数据
	 */
	data: {
		tabCur: 0,
		verticalNavTop: 0,
	},

	/**
	 * 在组件布局完成后执行
	 */
	ready: function () {
		this.Load();
	},

	/**
	 * 组件的方法列表
	 */
	methods: {
		// 选择事件
		TabSelect: function (e) {
			this.setData({
				tabCur: e.currentTarget.dataset.index,
				verticalNavTop: (e.currentTarget.dataset.index - 1) * 60
			});
			this.TriggerEvent(this.data.tabCur);
		},

		/**
		 * 触发事件
		 */
		TriggerEvent: function (index) {
			var myEventDetail = {
				component: "verticalNav",
				data: {
					id: this.data.list[index].Id
				}
			} // detail对象，提供给事件监听函数
			var myEventOption = {} // 触发事件的选项
			this.triggerEvent("myevent", myEventDetail, myEventOption);
		},

		/**
		 * 加载数据
		 */
		Load: function () {
			var page = this;
			if (app.Validate.Url(this.data.url)) {
				app.Request({
					url: this.data.url,
					method: "post",
					data: {},
					success: res => {
						page.setData({
							isLoad: false,
							list: res.data.data instanceof Array ? res.data.data : []
						});
						page.LoadSuccess();
					},
					fail: res => {
						wx.showToast({
							title: res.errMsg,
							icon: 'none',
							duration: 3000
						});
					}
				});
			} else {
				var timer = setTimeout(function () {
					var list = [];
					for (var i = 0; i < Math.ceil(Math.random() * 20 + 1); ++i) {
						list.push({
							Id: i,
							Name: "分类" + (i + 1)
						});
					}
					page.setData({
						isLoad: false,
						list: list,
					});
					page.LoadSuccess();
					clearTimeout(timer);
				}, Math.ceil(Math.random() * 6) * 500);
			}
		},

		/**
		 * 加载成功
		 */
		LoadSuccess: function () {
			this.TriggerEvent(this.data.tabCur);
		}
	}
})