// components/stepper/defaultStepper/defaultStepper.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    value: {
      type: Number,
      value: 0,
    },
    min: {
      type: Number,
      value: Number.MIN_SAFE_INTEGER,
    },
    max: {
      type: Number,
      value: Number.MAX_SAFE_INTEGER
    },
    step: {
      type: Number,
      value: 1
    }
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    /**
     * 减少
     */
    Less: function(e) {
      if (this.data.value > this.data.min) {
        var value = this.data.value - this.data.step < this.data.min ? this.data.min : this.data.value - this.data.step;
        this.setData({
          value: value
        });
      }
      this.ValueChange();
    },

    /**
     * 增加
     */
    Plus: function(e) {
      if (this.data.value < this.data.max) {
        var value = this.data.value + this.data.step > this.data.max ? this.data.max : this.data.value + this.data.step;
        this.setData({
          value: value
        });
      }
      this.ValueChange();
    },

    /**
     * 输入事件
     */
    OnInput: function(e) {
      var value = this.data.value;
      if (this.ValidateNumber(e.detail.value)) {
        value = parseFloat(e.detail.value) || value;
      }
      this.setData({
        value: value
      });
      this.ValueChange();
    },

    /**
     * 触发记不起值改变事件
     */
    ValueChange: function(index){
      var myEventDetail = {
        component: "defaultStepper",
        data: {
          value: this.data.value
        }
      } // detail对象，提供给事件监听函数
      var myEventOption = {} // 触发事件的选项
      this.triggerEvent("myevent", myEventDetail, myEventOption);
    },

    /**
     * 验证数字
     */
    ValidateNumber: function(value) {
      return /^(?:-?\d+|-?\d{1,3}(?:,\d{3})+)?(?:\.\d+)?$/.test(value);
    }
  }
})