const app = getApp();
const util = require("../../utils/util");
var input = {
    username: '',
    password: ''
}
Page({

    /**
     * 页面的初始数据
     */
    data: {
        passwordType: "password",
        passwordIcon: "attentionforbid",
		username: "",
		password: "",
		loginButtonText: "登录"
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function(options) {
        input.username = '';
        input.password = '';
    },

    /**
     * 显示密码
     */
    ShowPassword: function(e) {
        this.setData({
            passwordType: this.data.passwordIcon === "attention" ? "password" : "text",
            passwordIcon: this.data.passwordIcon === "attention" ? "attentionforbid" : "attention"
        });
    },

    /**
     * 改变账号输入框
     */
    ChangeAccount: function(e) {
        input.username = e.detail.value;
    },

    /**
     * 改变密码输入框
     */
    ChangePassword: function(e) {
        input.password = e.detail.value;
    },

    /**
     * 登录
     */
    Login: function(e) {
		this.setData({
			loginButtonText: "正在登录..."
        });
        var page = this;
        app.Login({
            data: {
                username: input.username,
                password: input.password
            },
            success: res => {
				this.setData({
					loginButtonText: "登录成功"
                });
                page.IsEasyPassword();
                // wx.redirectTo({
                //     url: '/pages/index/index',
                // });
            },
            fail: res => {
				this.setData({
					loginButtonText: "登录"
				});
                wx.showModal({
                  content: res.errMsg,
                });
            }
        });
    },

    /**
     * 判断是否是简单密码
     */
    IsEasyPassword: function (data) {
        app.Request({
            url: app.GetDomain() + '/api/BefriUser/IsEasyPassword',
            method: 'get',
            success: res => {
                if (res.isEasy) {
                    // 重置密码
                    wx.showModal({
                        content: '您使用的是初始密码，请重置密码！',
                        success: res => {
                            if (res.confirm) {
                                wx.redirectTo({
                                    url: '/pages/my/modifyPassword/index?isFirst=true',
                                });
                            }
                            else {
                                app.Logout();
                            }
                        }
                    });
                } else {
                    wx.redirectTo({
                        url: '/pages/index/index',
                    });
                }
            },
            fail: res => {
				this.setData({
					loginButtonText: "登录"
				});
                wx.showModal({
                  content: res.errMsg,
                });
            }
        });
    }
});