const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var employeeName = '';
var employeeCode = '';
var mdOrderNumber = '';
var deparment = '';
var workShop= '';
var mesMainProcessName = '';
var mesProcess = '';
var startMdOrderNumber = '';
var endMdOrderNumber = '';
var empName = '';

Page({

    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		today: '',
		confirmSTime: '',
		confirmETime: ''
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		var now = new Date();
		searchText = '';
		employeeName = '';
		employeeCode = '';
		mdOrderNumber = '';
		deparment = '';
		workShop = '';
		mesMainProcessName = '';
		mesProcess = '';
		startMdOrderNumber = '';
		endMdOrderNumber = '';
		empName = '';
		this.setData({
			loadType: 'loading',
			list: [],
			today: util.formatDate(now, "yyyy/MM/dd"),
			confirmSTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + "-1"), "yyyy-MM-dd"),
			confirmETime: util.formatDate(now, "yyyy-MM-dd")
		});
		page.Load();
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'searchText':
				searchText = e.detail.value;
			case 'empName':
				empName = e.detail.value;
		}
	},

    /**
     * 改变查询时间
     */
	ChangeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'confirmSTime':
				this.setData({
					confirmSTime: e.detail.value
				});
				break;
			case 'confirmETime':
				this.setData({
					confirmETime: e.detail.value
				});
				break;
		}
		this.Load();
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].confirmQuantity = util.floatRound(parseFloat(list[i].confirmQuantity), 2);
			list[i].payText = util.formatAmount(parseFloat(list[i].pay), 4);
			list[i].pieceWageText = util.formatAmount(parseFloat(list[i].pieceWage), 4);
			list[i].confirmTime = util.formatDate(util.parseDate(list[i].confirmTime), 'yyyy/MM/dd');
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/Balance/QueryDetailPieceWageV1',
			method: 'post',
			data: {
				confirmSTime: page.data.confirmSTime + ' 0:0:0',
				confirmETime: page.data.confirmETime + ' 23:59:59',
				employeeName: employeeName,
				employeeCode: employeeCode,
				mdOrderNumber: mdOrderNumber,
				deparment: deparment,
				workShop: workShop,
				mesMainProcessName: mesMainProcessName,
				mesProcess: mesProcess,
				startMdOrderNumber: startMdOrderNumber,
				endMdOrderNumber: endMdOrderNumber,
				empName: empName
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.details)) {
					allList = res.details;
				}
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},
});