const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var startMdOrderNumber = '';
var endMdOrderNumber = '';
var empName = '';

Page({

    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		today: "",
		startTime: "",
		endTime: ""
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		var now = new Date();
		searchText = '';
		startMdOrderNumber = '';
		endMdOrderNumber = '';
		empName = '';
		this.setData({
			loadType: 'loading',
			list: [],
			today: util.formatDate(now, "yyyy/MM/dd"),
			startTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + "-1"), "yyyy-MM-dd"),
			endTime: util.formatDate(now, "yyyy-MM-dd")
		});
		page.Load();
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'searchText':
				searchText = e.detail.value;
			case 'empName':
				empName = e.detail.value;
		}
	},

    /**
     * 改变查询时间
     */
	ChangeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'startTime':
				this.setData({
					startTime: e.detail.value
				});
				break;
			case 'endTime':
				this.setData({
					endTime: e.detail.value
				});
				break;
		}
		this.Load();
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].pieceWageText = util.formatAmount(parseFloat(list[i].pieceWage), 4);
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/Balance/QueryPieceWageV1',
			method: 'post',
			data: {
				startTime: page.data.startTime + ' 0:0:0',
				endTime: page.data.endTime + ' 23:59:59',
				startMdOrderNumber: startMdOrderNumber,
				endMdOrderNumber: endMdOrderNumber,
				empName: empName,
				workShop: '',
				balanceAccountsSTime: '',
				balanceAccountsETime: ''
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.details)) {
					allList = res.details;
				}
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
		return;
	}
});