const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var url = '';
var searchText = '';
var type = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		selectedIndex: 0,
		queryType: 10
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		searchText = '';
		type = options.type;
		switch (options.type) {
			// 组长
			case 'workGroupLeader':
				url = '/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkGroupLeaderForWeb';
				break;
			// 主管
			case 'workOrderApplication':
				this.setData({
					queryType: 0
				});
			case 'workshopSupervisor':
				url = '/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkshopSupervisorLeaderForWeb';
				break;
		}
		this.Load();
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var page = this;
		var now = new Date();
		this.setData({
			loadType: 'loading',
			list: [],
			queryType: 10,
			isJoin: true
		});
	},

	/**
	 * 选择
	 */
	Select: function () {
		if (this.data.selectedIndex > -1) {
			wx.setStorageSync('select', {
				name: 'departmentEmployee',
				data: this.data.list[this.data.selectedIndex]
			});
			wx.navigateBack();
		}
	},

	/**
	 * 改变查询类型
	 */
	ChangeQueryType: function (e) {
		var queryType = parseInt(e.currentTarget.dataset.type);
		if (type === 'workOrderApplication') {
			queryType = 0;
		}
		if (!isNaN(queryType)) {
			this.setData({
				queryType: queryType
			});
			this.Reload();
		}
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 清除查询
	 */
	ClearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.Search();
	},

	/**
	 * 选择行
	 */
	SelectRow: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			this.setData({
				selectedIndex: index
			});
		}
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + url,
			method: 'get',
			data: {
				queryType: page.data.queryType
			},
			success: res => {
				allList = util.arrayIsNullOrEmpty(res) ? list : res;
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '应用程序错误',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			list: [],
			pageIndex: 0
		});
		this.Load();
	},
})