const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var parent = {};
var workGroupMembers = null;
var getEmployeeUrl = '';
var isSelectedMember = false;
var isOtherGroup = false;
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		selectedIndex: 0
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		allList = [];
		searchText = '';
		parent = {};
		workGroupMembers = null;
		getEmployeeUrl = '';
		isSelectedMember = false;
		isOtherGroup = true;
		var page = this;
		var now = new Date();
		this.setData({
			loadType: 'loading',
			list: []
		});
		page.Load();

		const eventChannel = this.getOpenerEventChannel();
		eventChannel.on('parent', res => {
			if (!util.objectIsNullOrEmpty(res)) {
				parent = res;
				if (!util.stringIsNullOrWhiteSpace(parent.data.confirmWorkGroupMemberJson)) {
					isOtherGroup = false;
					workGroupMembers = JSON.parse(parent.data.confirmWorkGroupMemberJson);
				}
			}
		});
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var member = wx.getStorageSync('workGroupMember');
		var row = this.data.list[this.data.selectedIndex];
		if (!util.objectIsNullOrEmpty(member)) {
			switch (member.name) {
				case 'set':
					if (!util.arrayIsNullOrEmpty(member.data)) {
						isSelectedMember = true;
						workGroupMembers = [];
						for (var i = 0; i < member.data.length; i++) {
							workGroupMembers.push({
								EmployeeCode: member.data[i].employeeCode,
								EmployeeId: member.data[i].employeeId,
								EmployeeName: member.data[i].employeeName,
								PositionId: member.data[i].positionId,
								PositionName: member.data[i].positionName,
								Skill: member.data[i].skill,
								WorkDays: member.data[i].workDays
							});
						}
						if (isOtherGroup) {
							parent.data = row;
							parent.data.confirmWorkGroupMemberJson = JSON.stringify(workGroupMembers);
							isOtherGroup = false;
						}
					}
					break;
			}
		}
		wx.getStorageSync('workGroupMember', null);
	},

	/**
	 * 选择
	 */
	Select: function () {
		var row = parent.data;
		if (this.data.selectedIndex === -1) {
			return wx.showToast({
				title: '请选择工作组',
				icon: 'none',
			});
		}
		if (isSelectedMember && (util.arrayIsNullOrEmpty(workGroupMembers) || workGroupMembers.length === 0)) {
			return wx.showToast({
				title: '请选择工作组成员',
				icon: 'none',
			});
		}
		// 如果选择其他组
		if (isOtherGroup) {
			row = this.data.list[this.data.selectedIndex];
			return this.LoadWorkGroupMembers(row.workGroupId, function (res) {
				if (!util.arrayIsNullOrEmpty(res)) {
					var member = [];
					for (var i = 0; i < res.length; i++) {
						member.push({
							EmployeeCode: res[i].employeeCode,
							EmployeeId: res[i].employeeId,
							EmployeeName: res[i].employeeName,
							PositionId: res[i].positionId,
							PositionName: res[i].positionName,
							Skill: res[i].skill,
							WorkDays: res[i].workDays
						});
					}
					row.confirmWorkGroupMemberJson = JSON.stringify(member);
					wx.setStorageSync('select', {
						name: 'departmentWorkGroupAndMembers',
						data: row
					});
					wx.navigateBack();
				}
			});
		}
		// 如果未选择其他组，则设置默认成员或已选成员
		else {
			row.confirmWorkGroupMemberJson = JSON.stringify(workGroupMembers);
		}

		wx.setStorageSync('select', {
			name: 'departmentWorkGroupAndMembers',
			data: row
		});
		wx.navigateBack();
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 清除查询
	 */
	ClearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.Search();
	},

	/**
	 * 选择行
	 */
	SelectRow: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (this.data.list[index].workGroupId === parent.data.workGroupId) {
				isOtherGroup = false;
			}
			else {
				isOtherGroup = true;
			}
			this.setData({
				selectedIndex: index
			});
		}
		if (this.data.selectedIndex !== index) {
			isSelectedMember = false;
		}
	},

	/**
	 * 选择工作组成员
	 */
	SelectWorkGroupMember: function (e) {
		wx.setStorageSync('workGroupMember', null);
		var row = this.data.list[this.data.selectedIndex];
		var members = [];
		if (!isOtherGroup) {
			for (var i = 0; i < workGroupMembers.length; i++) {
				members.push({
					employeeCode: workGroupMembers[i].EmployeeCode,
					employeeId: workGroupMembers[i].EmployeeId,
					employeeName: workGroupMembers[i].EmployeeName,
					positionId: workGroupMembers[i].PositionId,
					positionName: workGroupMembers[i].PositionName,
					skill: workGroupMembers[i].Skill,
					workDays: workGroupMembers[i].WorkDays
				});
			}
		}
		wx.navigateTo({
			url: '/pages/workGroupMember/selectWorkGroupMemberByWorkGroupId/select?workGroupId=' + row.workGroupId,
			success: res => {
				res.eventChannel.emit('parent', {
					data: members,
					getEmployeeUrl: parent.getEmployeeUrl || '',
					isLoad: isOtherGroup,
					type: parent.type
				});
			}
		});
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		var i = 0;
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			// 把已选记录放到第一条
			for (i = 0; i < allList.length; i++) {
				// 查找选中项
				if (allList[i].workGroupId === parent.data.workGroupId) {
					if (i === 0) {
						break;
					}
					var row = allList[i];
					allList.splice(i, 1);
					// 设置选中项
					allList.unshift(row);
					break;
				}
			}
			for (i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/DepartmentWorkGroup/GetDepartmentWorkGroupFullInfoAllForWeb',
			method: 'get',
			success: res => {
				allList = util.arrayIsNullOrEmpty(res) ? list : res;
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			list: [],
			pageIndex: 0
		});
		this.Load();
	},

	/**
	 * 加载数据
	 */
	LoadWorkGroupMembers: function (workGroupId, fun) {
		if (this.data.isLoad || this.data.loadType === 'over' || util.stringIsNullOrWhiteSpace(workGroupId)) {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "正在处理...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/WorkGroupMember/GetWorkGroupMembersByWorkGroupIdForWeb?workGroupId=' + workGroupId,
			method: 'get',
			success: res => {
				page.setData({
					isLoad: false
				});
				if (!util.arrayIsNullOrEmpty(res)) {
					for (var i = 0; i < res.length; i++) {
						res[i].skill = parseFloat(res[i].skill) || '';
						res[i].workDays = parseFloat(res[i].workDays) || '';
					}
					if (typeof fun === 'function') {
						fun(res);
					}
				}
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	}
})