/**
 * 细分派工
 */
const app = getApp();
const util = require("../../../utils/util");
var parent = {};

// 工人
var departmentEmployee = {
    searchText: '',
    checkCount: 0,
    all: []
};

// 小组
var departmentWorkGroup = {
    searchText: '',
    all: []
};

// 小组成员
var departmentWorkGroupMembers = {
    searchText: '',
    all: []
};

// 编辑
var edit = {
    value: ''
};

Page({

    /**
     * 页面的初始数据
     */
    data: {
        StatusBar: app.globalData.StatusBar,
        CustomBar: app.globalData.CustomBar,
        Custom: app.globalData.Custom,
        user: {},
        isLoad: false,
        loadType: "loading",
        loadText: "加载中...",
        tabCur: 0,
        scrollLeft: 0,

        /**
         * 页签内容
         */
        tabs: [{
                name: '已选人组',
                isShow: true
            },
            {
                name: '工人',
                isShow: false
            },
            {
                name: '小组',
                isShow: false
            },
            {
                name: '临时小组',
                isShow: false
            }
        ],

        // 编辑
        edit: {
            index: null,
            field: null,
            name: null,
            text: '',
            type: 'text',
            focus: false,
            value: '',
            isShow: false
        },

        /**
         * 已选人组
         */
        subdivisionWorkGroupAndEmp: {
            allChecked: false,
            list: []
        },

        /**
         * 工人
         */
        departmentEmployee: {
            searchText: '',
            allChecked: false,
            checkIndex: -1,
            query: {
                queryType: 10
            },
            list: []
        },

        /**
         * 小组
         */
        departmentWorkGroup: {
            searchText: '',
            allChecked: false,
            checkIndex: 0,
            query: {
                queryType: 10
            },
            list: []
        },

        /**
         * 小组成员
         */
        departmentWorkGroupMembers: {
            searchText: '',
            allChecked: false,
            checkIndex: -1,
            query: {
                workGroupId: 0
            },
            list: [],
            isShow: false
        },

        /**
         * 临时小组
         */
        tempWorkGroup: {
            searchText: '',
            allChecked: false,
            checkIndex: -1,
            list: [],
            isShow: false
        }
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        switch (options.type) {
            // 主管
            case 'workshopSupervisor':
                // 工人地址
                this.departmentEmployee.url = '/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkshopSupervisorLeaderForWeb';
                // 小组地址
                this.departmentWorkGroup.url = '/api/DepartmentWorkGroup/GetDepartmentWorkGroupFullInfoByWorkshopSupervisorLeaderForWeb';
                break;
                // 组长
            case 'workGroupLeader':
                // 工人地址
                this.departmentEmployee.url = '/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkGroupLeaderForWeb';
                // 小组地址
                this.departmentWorkGroup.url = '/api/DepartmentWorkGroup/GetDepartmentWorkGroupFullInfoByWorkGroupLeaderForWeb';
                break;
        }
        // 小组成员地址
        this.departmentWorkGroupMembers.url = '/api/WorkGroupMember/GetWorkGroupMembersByWorkGroupIdForWeb';

        var page = this;
        var eventChannel = this.getOpenerEventChannel();
        eventChannel.on('parent', res => {
            if (!util.objectIsNullOrEmpty(res)) {
                parent = res;

                page.departmentEmployee.load();
                page.departmentWorkGroup.load();
            }
        });
    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        var i = 0;
        var data = null;
        var select = wx.getStorageSync('select');
        var ispush = true;
        if (!util.objectIsNullOrEmpty(select)) {
            switch (select.name) {
                case 'departmentEmployee':
                    this.departmentWorkGroupMembers.append(select.data);
                    break;
            }
        }
        wx.setStorageSync('select', null);
    },

    /**
     * 页签选择
     */
    tabSelect(e) {
        var tabs = this.data.tabs;
        for (var i = 0; i < tabs.length; i++) {
            if (i == e.currentTarget.dataset.index) {
                tabs[i].isShow = true;
            } else {
                tabs[i].isShow = false;
            }
        }
        this.setData({
            tabCur: e.currentTarget.dataset.index,
            scrollLeft: (e.currentTarget.dataset.index - 1) * 60,
            tabs: tabs
        });
    },

    /**
     * 点击复选框
     */
    tapCheckbox: function (e) {
        var i = 0;
        var key = '';
        var checked = e.currentTarget.dataset.checked == "true" || e.currentTarget.dataset.checked ? false : true;
        var data = null;
        var odata = null;

        switch (e.currentTarget.dataset.name) {
            case 'departmentEmployee':
                data = this.data.departmentEmployee;
                odata = departmentEmployee;
                break;
            case 'departmentWorkGroup':
                data = this.data.departmentWorkGroup;
                odata = departmentWorkGroup;
                break;
        }

        switch (e.currentTarget.dataset.type) {
            case 'all':
                for (i = 0; i < data.list.length; i++) {
                    data.list[i].checked = checked;
                }
                odata.checkCount = checked ? data.list.length : 0;
                break;
            case 'table':
            default:
                data.list[e.currentTarget.dataset.index].checked = checked;
                checked ? odata.checkCount++ : odata.checkCount--;
        }

        data.allChecked = odata.checkCount === data.list.length ? true : false;

        switch (e.currentTarget.dataset.name) {
            case 'departmentEmployee':
                this.setData({
                    departmentEmployee: data
                });
                break;
            case 'departmentWorkGroup':
                this.setData({
                    departmentWorkGroup: data
                });
                break;
        }
    },

    /**
     * 选择行
     */
    selectRow: function (e) {
        var index = parseInt(e.currentTarget.dataset.index);
        if (isNaN(index)) {
            return;
        }
        var data = null;
        switch (e.currentTarget.dataset.name) {
            case 'subdivisionWorkGroupAndEmp':
                data = this.data.subdivisionWorkGroupAndEmp;
                data.checkIndex = index;
                this.setData({
                    subdivisionWorkGroupAndEmp: data
                });
                break;
            case 'departmentWorkGroup':
                data = this.data.departmentWorkGroup;
                data.checkIndex = index;
                this.setData({
                    departmentWorkGroup: data
                });
                this.departmentWorkGroupMembers.load();
                break;
            case 'departmentWorkGroupMembers':
                data = this.data.departmentWorkGroupMembers;
                data.checkIndex = index;
                this.setData({
                    departmentWorkGroupMembers: data
                });
                break;
            case 'tempWorkGroup':
                data = this.data.tempWorkGroup;
                data.checkIndex = index;
                this.setData({
                    tempWorkGroup: data
                });
                break;
        }
    },

    /**
     * 点击覆盖层
     */
    tapCover: function (e) {
        var data = null;
        var isShow = e.currentTarget.dataset.show === 'true' ? true : false;
        switch (e.currentTarget.dataset.name) {
            case 'departmentWorkGroupMembers':
                if (this.data.departmentWorkGroup.checkIndex < 0) {
                    return;
                }
                data = this.data.departmentWorkGroupMembers;
                data.isShow = isShow;
                this.setData({
                    departmentWorkGroupMembers: data
                });
                break;
        }
    },

    /**
     * 点击
     */
    tap: function (e) {
        var name = e.currentTarget.dataset.name;
        var fun = e.currentTarget.dataset.fun;
        if (typeof this[name] === 'object' && typeof this[name][fun] === 'function') {
            this[name][fun](e);
        }
    },

    /**
     * 输入
     */
    input: function (e) {
        var name = e.currentTarget.dataset.name;
        var fun = e.currentTarget.dataset.fun;
        if (typeof this[name] === 'object' && typeof this[name][fun] === 'function') {
            this[name][fun](e);
        }
    },

    /**
     * 改变查询类型
     */
    changeQueryType: function (e) {
        var queryType = parseInt(e.currentTarget.dataset.type);
        if (isNaN(queryType)) {
            return;
        }
        switch (e.currentTarget.dataset.name) {
            case 'departmentEmployee':
                var departmentEmployee = this.data.departmentEmployee;
                departmentEmployee.query.queryType = queryType;
                this.setData({
                    departmentEmployee: departmentEmployee
                });
                this.departmentEmployee.load();
                break;
            case 'departmentWorkGroup':
                var departmentWorkGroup = this.data.departmentWorkGroup;
                departmentWorkGroup.query.queryType = queryType;
                this.setData({
                    departmentWorkGroup: departmentWorkGroup
                });
                this.departmentWorkGroup.load();
                break;
        }
        this.setData({
            isLoad: true
        });
    },

    /**
     * 搜索框输入事件
     */
    searchInput: function (e) {
        var odata = null
        switch (e.currentTarget.dataset.name) {
            case 'departmentEmployee':
                odata = departmentEmployee;
                odata.searchText = e.detail.value;
                break;
            case 'departmentWorkGroup':
                odata = departmentWorkGroup;
                odata.searchText = e.detail.value;
                break;
        }
    },

    /**
     * 清除搜索方法
     */
    clearSearch: function (e) {
        var odata = null
        switch (e.currentTarget.dataset.name) {
            case 'departmentEmployee':
                odata = departmentEmployee;
                odata.searchText = '';
                this.search('departmentEmployee');
                break;
            case 'departmentWorkGroup':
                odata = departmentWorkGroup;
                odata.searchText = '';
                this.search('departmentWorkGroup');
                break;
        }
    },

    /**
     * 搜索方法
     */
    search: function (e) {
        var data = null;
        var odata = null;
        var name = util.stringIsNullOrWhiteSpace(e) ? e.currentTarget.dataset.name : e;
        switch (name) {
            case 'departmentEmployee':
                data = this.data.departmentEmployee;
                odata = departmentEmployee;
                data.searchText = odata.searchText;
                data.checkIndex = -1;
                break;
            case 'departmentWorkGroup':
                data = this.data.departmentWorkGroup;
                odata = departmentWorkGroup;
                data.searchText = odata.searchText;
                break;
            case 'departmentWorkGroupMembers':
                data = this.data.departmentWorkGroupMembers;
                odata = departmentWorkGroupMembers;
                data.searchText = odata.searchText;
                break;
            default:
                return;
        }

        if (!util.stringIsNullOrWhiteSpace(odata.searchText)) {
            data.list = [];
            for (var i = 0; i < odata.all.length; i++) {
                for (var n in odata.all[i]) {
                    if (!util.objectIsNullOrEmpty(odata.all[i][n]) && odata.all[i][n].toString().indexOf(odata.searchText) >= 0) {
                        data.list.push(odata.all[i]);
                        break;
                    }
                }
            }
        } else {
            data.list = odata.all;
        }

        switch (name) {
            case 'departmentEmployee':
                this.setData({
                    isLoad: false,
                    departmentEmployee: data
                });
                break;
            case 'departmentWorkGroup':
                this.setData({
                    isLoad: false,
                    departmentWorkGroup: data
                });
                this.departmentWorkGroupMembers.load();
                break;
            case 'departmentWorkGroupMembers':
                this.setData({
                    isLoad: false,
                    departmentWorkGroupMembers: data
                });
                break;
        }
    },

    /**
     * 点击列
     */
    tapCol: function (e) {
        var index = parseInt(e.currentTarget.dataset.index);
        var field = e.currentTarget.dataset.field;
        var name = e.currentTarget.dataset.name;
        var text = e.currentTarget.dataset.text;
        var type = e.currentTarget.dataset.type;
        if (isNaN(index) || util.stringIsNullOrWhiteSpace(field)) {
            return;
        }
        var isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
        var edit = this.data.edit;
        var data = null;
        switch (name) {
            case 'departmentWorkGroupMembers':
                data = this.data.departmentWorkGroupMembers;
                break;
            case 'tempWorkGroup':
                data = this.data.tempWorkGroup;
        }
        data.list[index].isfocus = isfocus;
        if (!util.numberIsNullOrEmpty(edit.index) && index !== edit.index) {
            data.list[edit.index].isfocus = false;
        } else {
            data.list[index].isfocus = true;
        }
        edit.index = index;
        edit.field = field;
        edit.name = name;
        edit.text = text;
        edit.value = data.list[index][field];
        // 使输入框获得焦点
        edit.focus = true;
        edit.type = function () {
            switch (type) {
                case 'text':
                case 'number':
                case 'idcard':
                case 'digit':
                    return type;
                default:
                    return 'text';
            }
        }();
        edit.isShow = true;
        switch (name) {
            case 'departmentWorkGroupMembers':
                this.setData({
                    departmentWorkGroupMembers: data,
                    edit: edit
                });
                break;
            case 'tempWorkGroup':
                this.setData({
                    tempWorkGroup: data,
                    edit: edit
                });
                break;
        }
    },

    /**
     * 编辑
     */
    edit: {
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 隐藏
         */
        hide: function (e) {
            var page = this.parent();
            var data = page.data.edit;
            data.isShow = false;
            page.setData({
                edit: data
            });
        },

        /**
         * 输入
         */
        input: function (e) {
            edit.value = e.detail.value;
        },

        /**
         * 确认
         */
        confirm: function (e) {
            var page = this.parent();
            var value = null;
            var dedit = page.data.edit;
            var data = null;

            switch (dedit.name) {
                case 'departmentWorkGroupMembers':
                    data = page.data.departmentWorkGroupMembers;
                    break;
                case 'tempWorkGroup':
                    data = page.data.tempWorkGroup;
                    break;
            }

            switch (dedit.type) {
                case 'number':
                case 'digit':
                    value = parseFloat(edit.value);
                    if (isNaN(value) && !util.stringIsNullOrWhiteSpace(edit.value)) {
                        return wx.showToast({
                            title: '只能输入数字！',
                            icon: 'none',
                        });
                    }
                    break;
                default:
                    value = edit.value;
            }
            if (data.list[dedit.index][dedit.field] !== value) {
                data.list[dedit.index].isEdit = true;
            }
            data.list[dedit.index][dedit.field] = value;

            dedit.focus = false;
            dedit.isShow = false;

            switch (dedit.name) {
                case 'departmentWorkGroupMembers':
                    page.setData({
                        departmentWorkGroupMembers: data,
                        edit: dedit
                    });
                    break;
                case 'tempWorkGroup':
                    page.setData({
                        tempWorkGroup: data,
                        edit: dedit
                    });
                    break;
            }
        },
    },

    /**
     * 已选人组
     */
    subdivisionWorkGroupAndEmp: {
        url: '',
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 选择
         */
        select: function () {
            var page = this.parent();
            var data = page.data.subdivisionWorkGroupAndEmp;
            if(data.list.length === 0) {
                return wx.showModal({
                    title: '提示',
                    content: '您未选择任何个人或工作组！',
                });
            }
            wx.setStorageSync('select', {
                name: 'dispatchSubdivision',
                data: data.list
            });
            wx.navigateBack();
        },

        /**
         * 清空临时小组成员
         */
        clear: function () {
            var page = this.parent();
            wx.showModal({
                title: '提示',
                content: '确认要清空所有已选人组吗？',
                success(res) {
                    if (res.confirm) {
                        var data = page.data.subdivisionWorkGroupAndEmp;
                        data.list = [];
                        page.setData({
                            subdivisionWorkGroupAndEmp: data
                        });
                    }
                }
            });
        },

        /**
         * 删除
         */
        delete: function () {
            var page = this.parent();
            var data = page.data.subdivisionWorkGroupAndEmp;
            if (data.checkIndex > -1) {
                data.list.splice(data.checkIndex, 1);
            }
            page.setData({
                subdivisionWorkGroupAndEmp: data
            });
        },

        /**
         * 添加
         */
        append: function (row) {
            var page = this.parent();
            var data = page.data.subdivisionWorkGroupAndEmp;
            var ispush = true;
            var i = 0;
            if (!util.objectIsNullOrEmpty(row)) {
                for (i = 0; i < data.list.length; i++) {
                    if (data.list[i].subdivisionObjId === row.subdivisionObjId) {
                        ispush = false;
                    }
                }
                if (ispush) {
                    row.subdivisionObjTypeName = '';
                    switch (row.subdivisionObjTypeId) {
                        case 10:
                            row.subdivisionObjTypeName = '个人';
                            break;
                        case 20:
                            row.subdivisionObjTypeName = '小组';
                            break;
                    }
                    row.confirmWorkGroupMemberNames = '';
                    if (!util.stringIsNullOrWhiteSpace(row.confirmWorkGroupMemberJson)) {
                        var members = JSON.parse(row.confirmWorkGroupMemberJson);
                        for (i = 0; i < members.length; i++) {
                            row.confirmWorkGroupMemberNames += (i > 0 ? '，' : '') + members[i].employeeName;
                        }
                    }
                    data.list.push(row);
                    page.setData({
                        subdivisionWorkGroupAndEmp: data
                    });
                }
            }
        },
    },

    /**
     * 工人
     */
    departmentEmployee: {
        url: '',
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 加载数据
         */
        load: function () {
            var page = this.parent();
            page.setData({
                isLoad: true
            });
            page.load(this.url, page.data.departmentEmployee.query, function (res) {
                if (!util.arrayIsNullOrEmpty(res)) {
                    departmentEmployee.all = res;
                    page.search('departmentEmployee');
                    page.setData({
                        isLoad: false
                    });
                }
            });
        },

        /**
         * 选择
         */
        select: function () {
            var page = this.parent();
            var departmentEmployee = page.data.departmentEmployee;
            for (var i = 0; i < departmentEmployee.list.length; i++) {
                if (!departmentEmployee.list[i].checked) {
                    continue;
                }
                var row = {
                    confirmWorkGroupMemberJson: '',
                    subdivisionObjId: departmentEmployee.list[i].employeeId,
                    subdivisionObjTypeId: 10,
                    subdivisionObjName: departmentEmployee.list[i].employeeName,
                    isTempWorkGroup: false
                };
                page.subdivisionWorkGroupAndEmp.append(row);
            }
            wx.showToast({
              title: '已选择工作组',
            });
        },

        /**
         * 添加到临时小组
         */
        addToTempGroup: function (e) {
            var page = this.parent();
            var data = page.data.departmentEmployee;
            var list = [];
            var i = 0;
            for (i = 0; i < data.list.length; i++) {
                if (data.list[i].checked) {
                    list.push(data.list[i]);
                }
            }
            if (list.length === 0) {
                return wx.showToast({
                    title: '请勾选工人！',
                    icon: 'none',
                });
            }
            for (i = 0; i < list.length; i++) {
                page.tempWorkGroup.append(list[i]);
            }
            wx.showToast({
              title: '已添加到临时小组',
            });
        }
    },

    /**
     * 小组
     */
    departmentWorkGroup: {
        url: '',
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 加载数据
         */
        load: function () {
            var page = this.parent();
            page.setData({
                isLoad: true
            });
            page.load(this.url, page.data.departmentWorkGroup.query, function (res) {
                if (!util.arrayIsNullOrEmpty(res)) {
                    departmentWorkGroup.all = res;
                    page.search('departmentWorkGroup');
                    if (res.length === 0) {
                        page.data.departmentWorkGroup.checkIndex = -1;
                    }
                    page.departmentWorkGroupMembers.load();
                }
            });
        },

        /**
         * 选择
         */
        select: function () {
            var page = this.parent();
            var departmentWorkGroup = page.data.departmentWorkGroup;
            var departmentWorkGroupMembers = page.data.departmentWorkGroupMembers;
            var row = {
                confirmWorkGroupMemberJson: JSON.stringify(departmentWorkGroupMembers.list),
                subdivisionObjId: departmentWorkGroup.list[departmentWorkGroup.checkIndex].workGroupId,
                subdivisionObjTypeId: 20,
                subdivisionObjName: departmentWorkGroup.list[departmentWorkGroup.checkIndex].workGroupName,
                isTempWorkGroup: false
            };
            page.subdivisionWorkGroupAndEmp.append(row);
            wx.showToast({
              title: '已选择工作组',
            });
        }
    },

    /**
     * 小组成员
     */
    departmentWorkGroupMembers: {
        url: '',
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 加载数据
         */
        load: function () {
            var page = this.parent();
            var departmentWorkGroup = page.data.departmentWorkGroup;
            if (departmentWorkGroup.checkIndex < 0 || departmentWorkGroup.list.length === 0) {
                return;
            }
            var data = page.data.departmentWorkGroupMembers;
            data.query.workGroupId = departmentWorkGroup.list[departmentWorkGroup.checkIndex].workGroupId;
            data.list = [];
            page.setData({
                isLoad: true,
                departmentWorkGroupMembers: data
            });
            page.load(this.url, page.data.departmentWorkGroupMembers.query, function (res) {
                if (!util.arrayIsNullOrEmpty(res)) {
                    for (var i = 0; i < res.length; i++) {
                        res[i].skill = parseFloat(res[i].skill) || '';
                        res[i].workDays = parseFloat(res[i].workDays) || '';
                    }
                    departmentWorkGroupMembers.all = res;
                    page.search('departmentWorkGroupMembers');
                    page.setData({
                        isLoad: false
                    });
                }
            });
        },

        /**
         * 新增
         */
        add: function () {
            wx.navigateTo({
                url: '/pages/departmentEmployee/select/select?type=' + parent.type || '',
            });
        },

        /**
         * 删除
         */
        delete: function () {
            var page = this.parent();
            var data = page.data.departmentWorkGroupMembers;
            if (data.checkIndex > -1) {
                data.list.splice(data.checkIndex, 1);
            }
            page.setData({
                departmentWorkGroupMembers: data
            });
        },

        /**
         * 添加
         */
        append: function (row) {
            var page = this.parent();
            var data = page.data.departmentWorkGroupMembers;
            var ispush = true;
            if (!util.objectIsNullOrEmpty(row)) {
                for (var i = 0; i < data.list.length; i++) {
                    if (data.list[i].employeeId === row.employeeId) {
                        ispush = false;
                    }
                }
                if (ispush) {
                    row.skill = 0;
                    data.list.push(row);
                    page.setData({
                        departmentWorkGroupMembers: data
                    });
                }
            }
        },
    },

    /**
     * 临时小组
     */
    tempWorkGroup: {
        url: '',
        parent: function () {
            return getCurrentPages()[getCurrentPages().length - 1];
        },

        /**
         * 创建临时小组
         */
        create: function () {
            var page = this.parent();
            var data = page.data.tempWorkGroup;
            if (!page.checkEmployee(data.list)) {
                return false;
            }
            app.Request({
                url: app.GetDomain() + '/api/WorkGroup/GenerateTempWorkGroupForWeb',
                method: 'post',
                data: {
                    generatedTempWorkGroupIds: page.tempWorkGroup.tempWorkGroupIds,
                    tempWorkGroupMembers: data.list
                },
                success: res => {
                    var createSuccess = true;
                    if (res.tempWorkGroupId <= 0) {
                        createSuccess = false;
                    }
                    else {
                        var subdivisionWorkGroupAndEmp = page.data.subdivisionWorkGroupAndEmp;
                        for (var i = 0; i < subdivisionWorkGroupAndEmp.list.length; i++) {
                            if (subdivisionWorkGroupAndEmp.list[i].subdivisionObjId === res.tempWorkGroupId && subdivisionWorkGroupAndEmp.list[i].SubdivisionObjTypeId === 20) {
                                createSuccess = false;
                            }
                        }
                    }
                    if (!createSuccess) {
                        return wx.showModal({
                            title: '创建临时小组失败！',
                            content: res.errMsg,
                        });
                    }
                    var row = {
                        confirmWorkGroupMemberJson: JSON.stringify(res.generatedTempWorkGroupMembers),
                        subdivisionObjId: res.tempWorkGroupId,
                        subdivisionObjTypeId: 20,
                        subdivisionObjName: res.tempWorkGroupName,
                        isTempWorkGroup: true
                    };
                    page.subdivisionWorkGroupAndEmp.append(row);
                    data.list = [];
                    page.tempWorkGroup.tempWorkGroupIds.push(res.tempWorkGroupId);
                    page.setData({
                        tempWorkGroup: data
                    });
                    wx.showToast({
                        title: '已创建临时工作组',
                    });
                },
                fail: res => {
                    wx.showModal({
                        title: '应用程序错误',
                        content: res.errMsg,
                    });
                },
            });
        },

        // 已创建临时小组内码表
        tempWorkGroupIds: [],

        /**
         * 清空临时小组成员
         */
        clear: function () {
            var page = this.parent();
            wx.showModal({
                title: '提示',
                content: '确认要清空所有临时小组成员吗？',
                success(res) {
                    if (res.confirm) {
                        var data = page.data.tempWorkGroup;
                        data.list = [];
                        page.setData({
                            tempWorkGroup: data
                        });
                    }
                }
            });
        },

        /**
         * 删除
         */
        delete: function () {
            var page = this.parent();
            var data = page.data.tempWorkGroup;
            if (data.checkIndex > -1) {
                data.list.splice(data.checkIndex, 1);
            }
            page.setData({
                tempWorkGroup: data
            });
        },

        /**
         * 添加
         */
        append: function (row) {
            var page = this.parent();
            var data = page.data.tempWorkGroup;
            var ispush = true;
            if (!util.objectIsNullOrEmpty(row)) {
                for (var i = 0; i < data.list.length; i++) {
                    if (data.list[i].employeeId === row.employeeId) {
                        ispush = false;
                    }
                }
                if (ispush) {
                    row.skill = 0;
                    data.list.push(row);
                }
            }
            page.setData({
                tempWorkGroup: data
            });
        },
    },

    /**
     * 验证工人
     */
    checkEmployee: function (list) {
        if (util.arrayIsNullOrEmpty(list)) {
            return false;
        }
		var hasWorkDays = false;
		var isSkillChecked = true;
		var isWorkDaysChecked = true;
		for (var i = 0; i < list.length; i++) {
			// 成员比例必须填写
			if (util.numberIsNullOrEmpty(list[i].skill) || list[i].skill === 0) {
				isSkillChecked = false;
			}

			// 判断工作天数是否填写
			if (hasWorkDays && (util.numberIsNullOrEmpty(list[i].workDays) || list[i].workDays === 0)) {
				isWorkDaysChecked = false;
			}
			else if (!util.numberIsNullOrEmpty(list[i].workDays) && list[i].workDays > 0) {
				hasWorkDays = true;
			}
		}
		if (!isSkillChecked) {
			wx.showToast({
				title: '所选小组中有未编辑的小组成员比例！',
				icon: 'none',
				duration: 5000
            });
            return false;
		}
		if (!isWorkDaysChecked) {
			wx.showToast({
				title: '所选小组中如果有填写工作天数，则所有成员都必须填写大于0的工作天数！',
				icon: 'none',
				duration: 5000
			});
            return false;
        }
        return true;
    },

    /**
     * 加载数据
     */
    load: function (url, query, callback) {
        var page = this;
        app.Request({
            url: app.GetDomain() + url,
            method: 'get',
            data: query,
            success: res => {
                if (typeof callback === 'function') {
                    callback(res);
                }
            },
            fail: res => {
                page.setData({
                    isLoad: false,
                    loadType: 'erro'
                });
                wx.showModal({
                    title: '应用程序错误',
                    content: res.errMsg,
                });
            }
        });
    }
});