/**
 * 选择派工
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var selectCount = 0;
var selectRowIndex = -1;
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		query: {
			Status: 20,
			QueryType: 10,
			JoinQueryType: 10,
			SearchText: '',
			MesItemSearchText: '',
			WorkGroupSearchText: '',
			MesProcessWorkShop: '',
			MesMainProcessName: '',
			ModifiedSTime: '',
			ModifiedETime: '',
			Skip: 0,
			Take: 100000
		},


		// 表格是否全选
		allChecked: false,
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function () {
		searchText = '';
		this.Load();
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		selectCount = 0;
		this.setData({
			loadType: 'loading',
			list: [],
			queryType: 10,
			isJoin: true,
			allChecked: false
		});
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 清除查询
	 */
	ClearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.Search();
	},

	/**
	 * 输入框事件
	 */
	OnInput: function (e) {
		var query = this.data.query;
		query[e.currentTarget.dataset.name] = e.detail.value;
		this.setData({
			query: query
		});
	},

	/**
	 * 表格列点击事件
	 */
	OnTableCol: function (e) {
		var rowindex = parseInt(e.currentTarget.dataset.rowindex);
		var name = e.currentTarget.dataset.name;
		var text = e.currentTarget.dataset.text;
		var type = e.currentTarget.dataset.type;
		var list = this.data.list;
		var tableEdit = this.data.tableEdit;
		if (!isNaN(rowindex) && !util.stringIsNullOrWhiteSpace(name)) {
			list[rowindex].isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
			if (!util.numberIsNullOrEmpty(tableEdit.rowindex) && rowindex !== tableEdit.rowindex) {
				list[tableEdit.rowindex].isfocus = false;
			}
			else {
				list[rowindex].isfocus = true;
			}
			tableEdit.rowindex = rowindex;
			tableEdit.name = name;
			tableEdit.text = text;
			tableEdit.value = list[rowindex][name];
			// 使输入框获得焦点
			tableEdit.focus = true;
			tableEdit.type = function () {
				switch (type) {
					case 'text':
					case 'number':
					case 'idcard':
					case 'digit':
						return type;
					default:
						return 'text';
				}
			}();
			this.setData({
				list: list,
				tableEdit: tableEdit,
				isShowEditModal: true
			});
		}
	},

	/**
	 * 右侧遮罩事件
	 */
	OnRightCover: function (e) {
		this.setData({
			isShowRightCover: e.currentTarget.dataset.type === 'show' ? true : false
		});
	},

	/**
	 * 搜索框输入事件
	 */
	OnCheckbox: function (e) {
		var i = 0;
		var key = '';
		var checked = e.currentTarget.dataset.checked == "true" || e.currentTarget.dataset.checked ? false : true;
		var list = this.data.list;
		switch (e.currentTarget.dataset.type) {
			case 'all':
				for (i = 0; i < list.length; i++) {
					list[i].checked = checked;
				}
				selectCount = checked ? list.length : 0;
				this.setData({
					allChecked: checked,
					list: list
				});
				break;
			case 'table':
			default:
				list[e.currentTarget.dataset.index].checked = checked;
				checked ? selectCount++ : selectCount--;
				this.setData({
					allChecked: selectCount === list.length,
					list: list
				});
		}
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].pay = util.floatRound(parseFloat(list[i].pay), 2);
			list[i].workingSeconds = util.floatRound(parseFloat(list[i].workingSeconds), 2);
			list[i].startTime = util.formatDate(util.parseDate(list[i].startTime), 'yyyy/M/d');
			list[i].endTime = util.formatDate(util.parseDate(list[i].endTime), 'yyyy/M/d');
			list[i].confirmTime = util.formatDate(util.parseDate(list[i].confirmTime), 'yyyy/M/d');
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		var query = this.data.query;
		query.SearchText = searchText;
		app.Request({
			url: app.GetDomain() + '/api/Dispatch/QueryForWeb',
			method: 'get',
			data: query,
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
				}
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showToast({
					title: res.errMsg,
					icon: 'none',
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			pageIndex: 1
		});
		this.Load();
	},

	/**
	 * 选择
	 */
	Select: function () {
		var list = [];
		for (var i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].checked) {
				list.push(this.data.list[i]);
			}
		}
		if (list.length === 0) {
			return wx.showToast({
				title: '请勾选组长',
				icon: 'none',
			});
		}
		wx.setStorageSync('select', {
			name: 'dispatch',
			data: list
		});
		wx.navigateBack();
	},
});