//index.js
//获取应用实例
const app = getApp()

Page({
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		pageCur: "",
		titleName: "",
	},
	onLoad: function (option) {
		this.setData({
			pageCur: option.pageCur || "home",
			defaultTitle: this.selectComponent('#defaultTitle')
		});
		return false;
	},

    /**
     * 生命周期函数--监听页面显示
     */
	onShow: function () {
		this.NavChange({
			detail: {
				data: {
					pageCur: this.data.pageCur
				}
			}
		});
	},

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
	onPullDownRefresh: function () {
		var page = this.selectComponent("#" + this.data.pageCur);
		if (typeof page.onPullDownRefresh === 'function') {
			page.onPullDownRefresh();
		}
	},

    /**
     * 页面上拉触底事件的处理函数
     */
	onReachBottom: function () {
		var page = this.selectComponent("#" + this.data.pageCur);
		if (typeof page.onReachBottom === 'function') {
			page.onReachBottom();
		}
	},

	// 页面底部导航改变事件
	NavChange: function (e) {
		var titleName = "";
		var page = null;
		switch (e.detail.data.pageCur) {
			case "home":
				titleName = "首页";
				break;
			case "my":
				titleName = "我的";
				break;
			case "pieceWage":
				titleName = "计件工资查询";
				break;
			case "detailPieceWage":
				titleName = "计件工资明细查询";
				break;
			case "workshopSupervisor":
				titleName = "主管派工";
				break;
			case "group":
				titleName = "组长派工";
				break;
		}
		this.setData({
			pageCur: e.detail.data.pageCur,
			titleName: titleName
		});
		switch (e.detail.data.pageCur) {
			case "home":
				page = this.selectComponent("#home");
				break;
			case "my":
				page = this.selectComponent("#my");
				break;
			case "pieceWage":
				page = this.selectComponent("#pieceWage");
				break;
			case "detailPieceWage":
				page = this.selectComponent("#detailPieceWage");
				break;
			case "workshopSupervisor":
				page = this.selectComponent("#workshopSupervisor");
				break;
			case "group":
				page = this.selectComponent("#group");
				break;
		}

		if (typeof page.onLoad === 'function') {
			page.onLoad();
		}
		if (typeof page.onShow === 'function') {
			page.onShow();
		}
		var timer = setTimeout(function () {
			if(typeof page.onReady === 'function') {
				page.onReady();
			}
			clearTimeout(timer);
		}, 500);
	},

    /**
     * 页面事件
     */
	PageEvent: function (e) {
		switch (e.detail.type) {
			case "setTitle":
				var title = this.selectComponent("#defaultTitle");
				title.setData({
					isCustom: e.detail.data.isCustom || false,
					customIcon: e.detail.data.customIcon || "",
					customText: e.detail.data.customText || "",
					page: e.detail.page || {},
					callback: e.detail.callback || null
				});
				break;
			case "navChange":
				this.NavChange(e);
				break;
		}
	},
});