/**
 * 我的派工
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var input = {
	sMdOrderNumber: '',
	eMdOrderNumber: ''
};

Page({

    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		today: "",
		sTime: "",
		eTime: "",
		sMdOrderNumber: "",
		eMdOrderNumber: ""
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		var now = new Date();
		searchText = '';
		input = {
			sMdOrderNumber: '',
			eMdOrderNumber: ''
		};
		this.setData({
			loadType: 'loading',
			list: [],
			today: util.formatDate(now, "yyyy/MM/dd"),
			sTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + "-1"), "yyyy-MM-dd"),
			eTime: util.formatDate(now, "yyyy-MM-dd")
		});
		page.load();
	},

	/**
	 * 搜索框输入事件
	 */
	onSearchInput: function (e) {
		searchText = e.detail.value;
	},

	/**
	 * 清除查询
	 */
	clearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.search();
	},

    /**
     * 改变查询时间
     */
	changeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'sTime':
				this.setData({
					sTime: e.detail.value
				});
				break;
			case 'eTime':
				this.setData({
					eTime: e.detail.value
				});
				break;
		}
		this.load();
	},

    /**
     * 输入
     */
    input: function (e) {
		var name = e.currentTarget.dataset.name;
		var type = e.currentTarget.dataset.type;
		var value = e.detail.value;
		switch(type) {
			case 'number':
				value = parseFloat(value);
				break;
		}
		input[name] = value;
    },

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	gotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.load(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	search: function (pageIndex, totalCount) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = 0;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].quantity = parseFloat(list[i].quantity);
			list[i].wSDispatchQty = parseFloat(list[i].wSDispatchQty);
			list[i].wGLDispatchQty = parseFloat(list[i].wGLDispatchQty);
			list[i].confimDispatchQty = parseFloat(list[i].confimDispatchQty);
			list[i].aplWorkOrderQty = parseFloat(list[i].aplWorkOrderQty);
			list[i].confimWorkOrderQty = parseFloat(list[i].confimWorkOrderQty);
			list[i].pay = parseFloat(list[i].pay);
			list[i].createdOn  = util.formatDate(list[i].createdOn, 'yyyy/M/d');
			list[i].confirmTime = util.formatDate(list[i].confirmTime, 'yyyy/M/d');

			list[i].quantity = isNaN(list[i].quantity) ? 0 : list[i].quantity;
			list[i].wSDispatchQty = isNaN(list[i].wSDispatchQty) ? 0 : list[i].wSDispatchQty;
			list[i].wGLDispatchQty = isNaN(list[i].wGLDispatchQty) ? 0 : list[i].wGLDispatchQty;
			list[i].confimDispatchQty = isNaN(list[i].confimDispatchQty) ? 0 : list[i].confimDispatchQty;
			list[i].aplWorkOrderQty = isNaN(list[i].aplWorkOrderQty) ? 0 : list[i].aplWorkOrderQty;
			list[i].confimWorkOrderQty = isNaN(list[i].confimWorkOrderQty) ? 0 : list[i].confimWorkOrderQty;
			list[i].pay = isNaN(list[i].pay) ? 0 : list[i].pay;
		}
		totalCount = util.numberIsNullOrEmpty(totalCount) ? list.length : totalCount;
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: totalCount,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	load: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex;
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/ManualDisptch/QueryManualPagedCurrentUserDispatch',
			method: 'get',
			data: {
				SMdOrderNumber: input.sMdOrderNumber,
				EMdOrderNumber: input.eMdOrderNumber,
				Skip: (pageIndex - 1) * page.data.pageSize,
				Take: page.data.pageSize
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
				}
				page.search(pageIndex, res.totalCount);
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					content: res.errMsg
				});
			}
		});
		return;
	}
});