/**
 * 修改密码
 */
const app = getApp();
const util = require("../../../utils/util");
var input = {
	oldPassWord: '',
	password: '',
	rePassword: ''
};

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		user: {},
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		isFirst: false
	},

	/**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		input.oldPassWord = '';
		input.password = '';
		input.rePassword = '';
		if (options.isFirst === 'true') {
			this.setData({
				isFirst: true
			});
		}
	},

    /**
     * 输入
     */
    input: function (e) {
		var name = e.currentTarget.dataset.name;
		var type = e.currentTarget.dataset.type;
		var value = e.detail.value;
		switch(type) {
			case 'number':
				value = parseFloat(value);
				break;
		}
		input[name] = value;
	},
	
	/**
	 * 保存
	 */
	save: function () {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		if (input.password !== input.rePassword) {
			return wx.showModal({
				content: '新密码不一致！'
			});
		}
		if (input.password === input.oldPassWord) {
			return wx.showModal({
				content: '新密码不能与旧密码相同！'
			});
		}
		this.setData({
			isLoad: true,
			loadText: "正在保存...",
		});
		app.GetCurrentUser({
			success: res => {
				var result = res;
				app.Request({
					url: app.GetDomain() + '/api/BefriUser/UpdatePassword',
					method: 'post',
					data: {
						id: result.id,
						oldCleartextPassword: input.oldPassWord,
						newCleartextPassword: input.password
					},
					success: res => {
						page.setData({
							isLoad: false
						});
						wx.showModal({
							content: '密码修改成功，请重新登录！',
							success: res => {
								app.Logout({
									success: () => {
										wx.redirectTo({
											url: '/pages/account/index',
										});
									},
									fail: res => {
										wx.showToast({
											title: res.errMsg,
											icon: 'none'
										});
									}
								});
							}
						});
					},
					fail: res => {
						page.setData({
							isLoad: false,
							loadType: 'erro'
						});
						wx.showModal({
							content: res.errMsg
						});
					}
				});
			},
			fail: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: res.errMsg,
					icon: 'none'
				});
			}
		});
		var page = this;
		
	}
});