/**
 * 消息列表
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
Page({
	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		searchInputValue: '',
		pageIndex: 0,
		pageSize: 500,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		query: {
			CreateTime: '',
			Skip: 0,
			Take: 100000
		}
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		var query = this.data.query;
		if (!util.stringIsNullOrEmpty(options.date)) {
			query.CreateTime = options.date;
		}
		this.load();
	},

	/**
	 * 生命周期函数--监听页面初次渲染完成
	 */
	onReady: function () {

	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {

	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	gotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > allList.length ? allList.length : pageIndex * this.data.pageSize;
		var list = [];
		for (start; start < end; start++) {
			list.push(allList[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].createdOnText = util.formatDate(util.parseDate(list[i].createdOn), 'yyyy-M-d H:m:s');
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: allList.length,
			isLoad: false,
			allChecked: false
		});
	},

	/**
	 * 加载数据
	 */
	load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		allList = [];
		searchText = '';
		var page = this;
		var query = this.data.query;
		query.SearchText = searchText;
		app.Request({
			url: app.GetDomain() + '/api/Notice/GetPagedByCurrentUserForWeb',
			method: 'get',
			data: query,
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
				}
				page.search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	reload: function (e) {
		this.setData({
			pageIndex: 1
		});
		this.load();
	},

	/**
	 * 打开明细页
	 */
	openDetails: function(e) {
		for (var i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].id === e.currentTarget.dataset.id) {
				return wx.navigateTo({
					url: '/pages/notices/details/details',
					success: res => {
						res.eventChannel.emit('sendNotice', this.data.list[i]);
					}
				});
			}
		}
	}
})