/**
 * 流程生产查询
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var input = {
	sMdOrderNumber: '',
	eMdOrderNumber: ''
};

Page({

    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		today: "",
		sTime: "",
		eTime: "",
		sMdOrderNumber: "",
		eMdOrderNumber: ""
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		var now = new Date();
		searchText = '';
		input = {
			sMdOrderNumber: '',
			eMdOrderNumber: ''
		};
		this.setData({
			loadType: 'loading',
			list: [],
			today: util.formatDate(now, "yyyy/MM/dd"),
			sTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + '-' + (now.getDate() - 1)), "yyyy-MM-dd"),
			eTime: util.formatDate(now, "yyyy-MM-dd")
		});
		page.load();
	},

	/**
	 * 搜索框输入事件
	 */
	onSearchInput: function (e) {
		searchText = e.detail.value;
	},

	/**
	 * 清除查询
	 */
	clearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.search();
	},

    /**
     * 改变查询时间
     */
	changeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'sTime':
				this.setData({
					sTime: e.detail.value
				});
				break;
			case 'eTime':
				this.setData({
					eTime: e.detail.value
				});
				break;
		}
		this.load();
	},

    /**
     * 输入
     */
    input: function (e) {
		var name = e.currentTarget.dataset.name;
		var type = e.currentTarget.dataset.type;
		var value = e.detail.value;
		switch(type) {
			case 'number':
				value = parseFloat(value);
				break;
		}
		input[name] = value;
    },

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	gotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/Report/GetAllStatusMesProductionOrderProcess',
			method: 'post',
			data: {
				sTime: page.data.sTime + ' 0:0:0',
				eTime: page.data.eTime + ' 23:59:59',
				sMdOrderNumber: input.sMdOrderNumber,
				eMdOrderNumber: input.eMdOrderNumber
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
					for (var i = 0; i < allList.length; i++) {
						allList[i].quantity = parseFloat(allList[i].quantity);
						allList[i].wSDispatchQty = parseFloat(allList[i].wSDispatchQty);
						allList[i].wGLDispatchQty = parseFloat(allList[i].wGLDispatchQty);
						allList[i].confimDispatchQty = parseFloat(allList[i].confimDispatchQty);
						allList[i].aplWorkOrderQty = parseFloat(allList[i].aplWorkOrderQty);
						allList[i].confimWorkOrderQty = parseFloat(allList[i].confimWorkOrderQty);
						allList[i].pay = parseFloat(allList[i].pay);

						allList[i].quantity = isNaN(allList[i].quantity) ? 0 : allList[i].quantity;
						allList[i].wSDispatchQty = isNaN(allList[i].wSDispatchQty) ? 0 : allList[i].wSDispatchQty;
						allList[i].wGLDispatchQty = isNaN(allList[i].wGLDispatchQty) ? 0 : allList[i].wGLDispatchQty;
						allList[i].confimDispatchQty = isNaN(allList[i].confimDispatchQty) ? 0 : allList[i].confimDispatchQty;
						allList[i].aplWorkOrderQty = isNaN(allList[i].aplWorkOrderQty) ? 0 : allList[i].aplWorkOrderQty;
						allList[i].confimWorkOrderQty = isNaN(allList[i].confimWorkOrderQty) ? 0 : allList[i].confimWorkOrderQty;
						allList[i].pay = isNaN(allList[i].pay) ? 0 : allList[i].pay;
					}
				}
				page.search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showToast({
					title: res.errMsg,
					icon: 'none',
				});
			}
		});
		return;
	}
});