/**
 * 生产进度
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var input = {
	startOrderNum: '',
	endOrderNum: '',
	startCustomNum: '',
	endCustomNum: ''
};

Page({
    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		dynamicFields: [],
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		startOrderNum: "",
		endOrderNum: "",
		startCustomNum: '',
		endCustomNum: ''
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		var now = new Date();
		searchText = '';
		input.startOrderNum = '';
		input.endOrderNum = '';
		input.startCustomNum = '';
		input.endCustomNum = '';
		this.setData({
			loadType: 'loading',
			list: []
		});
	},

	/**
	 * 搜索框输入事件
	 */
	onSearchInput: function (e) {
		searchText = e.detail.value;
	},

	/**
	 * 清除查询
	 */
	clearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.search();
	},

    /**
     * 改变查询时间
     */
	changeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'sTime':
				this.setData({
					sTime: e.detail.value
				});
				break;
			case 'eTime':
				this.setData({
					eTime: e.detail.value
				});
				break;
		}
		this.load();
	},

    /**
     * 输入
     */
    input: function (e) {
		var name = e.currentTarget.dataset.name;
		var type = e.currentTarget.dataset.type;
		var value = e.detail.value;
		switch(type) {
			case 'number':
				value = parseFloat(value);
				break;
		}
		input[name] = value;
    },

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	gotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.load(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	search: function (pageIndex, totalCount) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		totalCount = util.numberIsNullOrEmpty(totalCount) ? list.length : totalCount;
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: totalCount,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	load: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex;
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/Report/GetProductionProgress',
			method: 'post',
			data: {
				startOrderNum: input.startOrderNum,
				endOrderNum: input.endOrderNum,
				startCustomNum: input.startCustomNum,
				endCustomNum: input.endCustomNum
			},
			success: res => {
				var i = 0;
				var j = 0;
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
					for (i = 0; i < allList.length; i++) {
						allList[i].realFinishedTime  = util.formatDate(allList[i].realFinishedTime, 'yyyy/M/d');
					}
				}
				// 构建动态字段
				if (allList.length > 0) {
					var dynamicFields = [];
					for (i = 0; i < allList[0].workshopFinishedInfos.length; i++) {
						dynamicFields.push(allList[0].workshopFinishedInfos[i].workShopName);
					}
					this.setData({
						dynamicFields: dynamicFields
					});
				}
				for (i = 0; i < allList.length; i++) {
					for (j = 0; j < allList[i].workshopFinishedInfos.length; j++) {
						allList[i].workshopFinishedInfos[j].finishedCompleteSetQty = util.numberIsNullOrEmpty(allList[i].workshopFinishedInfos[j].finishedCompleteSetQty) ? '' : allList[i].workshopFinishedInfos[j].finishedCompleteSetQty;
						if (allList[i].workshopFinishedInfos[j].finishedCompleteSetQty < allList[i].workshopFinishedInfos[j].completeSetQty) {
							allList[i].workshopFinishedInfos[j].isred = true;
						}else {
							allList[i].workshopFinishedInfos[j].isred = false;
						}
					}
				}
				console.log(allList);
				page.search(pageIndex, res.totalCount);
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					content: res.errMsg
				});
			}
		});
		return;
	},

	/**
	 * 打开明细
	 */
	openDetail: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		var infoindex = parseInt(e.currentTarget.dataset.infoindex);
		wx.navigateTo({
		  url: '/pages/report/productionProgressDetails/index?startOrderNum=' + this.data.list[index].mdOrderNumber + '&workshopName=' + this.data.dynamicFields[infoindex],
		})
	}
});