/**
 * 生产进度明细
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var searchText = '';
var input = {
	startOrderNum: '',
	endOrderNum: '',
	workshopName: '',
	mainMesProcessName: ''
};

Page({
    /**
     * 页面的初始数据
     */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		startOrderNum: "",
		endOrderNum: "",
		workshopName: '',
		mainMesProcessName: ''
	},

    /**
     * 生命周期函数--监听页面加载
     */
	onLoad: function (options) {
		var page = this;
		searchText = '';
		input.startOrderNum = util.stringIsNullOrWhiteSpace(options.startOrderNum) ? '' : options.startOrderNum;
		input.endOrderNum = input.startOrderNum;
		input.workshopName = util.stringIsNullOrWhiteSpace(options.workshopName) ? '' : options.workshopName;
		input.mainMesProcessName = '';
		this.setData({
			loadType: 'loading',
			list: []
		});
		if (!util.stringIsNullOrWhiteSpace(options.startOrderNum)){
			this.setData({
				startOrderNum: input.startOrderNum,
				endOrderNum: input.endOrderNum,
				workshopName: input.workshopName
			});
			this.load();
		}
	},

	/**
	 * 搜索框输入事件
	 */
	onSearchInput: function (e) {
		searchText = e.detail.value;
	},

	/**
	 * 清除查询
	 */
	clearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.search();
	},

    /**
     * 改变查询时间
     */
	changeSearchDate: function (e) {
		switch (e.currentTarget.dataset.name) {
			case 'sTime':
				this.setData({
					sTime: e.detail.value
				});
				break;
			case 'eTime':
				this.setData({
					eTime: e.detail.value
				});
				break;
		}
		this.load();
	},

    /**
     * 输入
     */
    input: function (e) {
		var name = e.currentTarget.dataset.name;
		var type = e.currentTarget.dataset.type;
		var value = e.detail.value;
		switch(type) {
			case 'number':
				value = parseFloat(value);
				break;
		}
		input[name] = value;
    },

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	gotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.load(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	search: function (pageIndex, totalCount) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		totalCount = util.numberIsNullOrEmpty(totalCount) ? list.length : totalCount;
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: totalCount,
			isLoad: false
		});
	},

    /**
     * 加载数据
     */
	load: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex;
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/Report/GetProductionProgressDetails',
			method: 'post',
			data: {
				startOrderNum: input.startOrderNum,
				endOrderNum: input.endOrderNum,
				workshopName: input.workshopName,
				mainMesProcessName: input.mainMesProcessName
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
					for (var i = 0; i < allList.length; i++) {
						allList[i].orderFinisiedTime  = util.formatDate(allList[i].orderFinisiedTime, 'yyyy/M/d');
						allList[i].maxWorkOrderTime  = util.formatDate(allList[i].maxWorkOrderTime, 'yyyy/M/d');
					}
				}
				page.search(pageIndex, res.totalCount);
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					content: res.errMsg
				});
			}
		});
		return;
	}
});