/**
 * 组长派工
 */
const app = getApp();
const util = require("../../../utils/util");
var selectCount = 0;
var selectRowIndex = -1;
var inputValue = '';
var allList = [];
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",

		// 表格是否全选
		allChecked: false,

		// 是否显示右侧菜单
		isShowRightCover: false,

		// 是否显示编辑窗口
		isShowEditModal: false,

		// 单元格编辑
		tableEdit: {
			rowindex: null,
			name: null,
			text: '',
			type: 'text',
			focus: false,
			value: ''
		},

		// 统计
		statistics: {
			quantity: 0
		}
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		selectCount = 0;
		selectRowIndex = -1;
		var page = this;
		var now = new Date();
		var tableEdit = this.data.tableEdit;
		tableEdit.focus = false;
		this.setData({
			loadType: 'loading',
			list: [],
			pageIndex: 0,
			today: util.formatDate(now, "yyyy-MM-dd"),
			confirmSTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + "-1"), "yyyy-MM-dd"),
			confirmETime: util.formatDate(now, "yyyy-MM-dd"),
			tableEdit: tableEdit,
			allChecked: false
		});
		page.Load();
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var i = 0;
		var list = this.data.list;
		var select = wx.getStorageSync('select');
		if (!util.objectIsNullOrEmpty(select)) {
			switch (select.name) {
				case 'departmentEmployee':
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].employeeId = select.data.employeeId;
								list[i].employeeName = select.data.employeeName;
								list[i].employeeCode = select.data.employeeCode;
								list[i].positionId = select.data.positionId;
								list[i].positionName = select.data.positionName;
								list[i].isEdit = true;

								// 清空小组
								list[i].confirmWorkGroupMemberJson = null;
								list[i].workGroupId = null;
								list[i].workGroupName = null;
								list[i].workGroupCode = null;
							}
						}
					}
					else if (selectRowIndex > -1) {
						list[selectRowIndex].employeeId = select.data.employeeId;
						list[selectRowIndex].employeeName = select.data.employeeName;
						list[selectRowIndex].employeeCode = select.data.employeeCode;
						list[selectRowIndex].positionId = select.data.positionId;
						list[selectRowIndex].positionName = select.data.positionName;
						list[selectRowIndex].isEdit = true;

						// 清空小组
						list[selectRowIndex].confirmWorkGroupMemberJson = null;
						list[selectRowIndex].workGroupId = null;
						list[selectRowIndex].workGroupName = null;
						list[selectRowIndex].workGroupCode = null;
					}
					selectRowIndex = -1;
					this.setData({
						list: list
					});
					wx.setStorageSync('select', null);
					break;
				case 'departmentWorkGroupAndMembers':
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].workGroupId = select.data.workGroupId;
								list[i].workGroupName = select.data.workGroupName;
								list[i].confirmWorkGroupMemberJson = select.data.confirmWorkGroupMemberJson;
								list[i].isEdit = true;

								// 清空员工、员工岗位
								list[i].positionId = null;
								list[i].positionName = null;
								list[i].employeeId = null;
								list[i].employeeCode = null;
								list[i].employeeName = null;
							}
						}
					}
					else if (selectRowIndex > -1) {
						list[selectRowIndex].workGroupId = select.data.workGroupId;
						list[selectRowIndex].workGroupName = select.data.workGroupName;
						list[selectRowIndex].confirmWorkGroupMemberJson = select.data.confirmWorkGroupMemberJson;
						list[selectRowIndex].isEdit = true;

						// 清空员工、员工岗位
						list[selectRowIndex].positionId = null;
						list[selectRowIndex].positionName = null;
						list[selectRowIndex].employeeId = null;
						list[selectRowIndex].employeeCode = null;
						list[selectRowIndex].employeeName = null;
					}
					selectRowIndex = -1;
					this.setData({
						list: list
					});
					wx.setStorageSync('select', null);
					break;
				case 'departmentWorkGroup':
					var groupleaderIdsText = '';
					var groupleaderIds = '';
					for (i = 0; i < select.data.length; i++) {
						groupleaderIdsText += (i > 0 ? ',' : '') + select.data[i].workGroupLeaderName;
						groupleaderIds += (i > 0 ? ',' : '') + select.data[i].workGroupLeaderId;
					}
					// 多选
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].groupleaderIdsText = groupleaderIdsText;
								list[i].groupleaderIds = groupleaderIds;
								list[i].isEdit = true;
							}
						}
					}
					// 单选
					else if (selectRowIndex > -1) {
						list[selectRowIndex].groupleaderIdsText = groupleaderIdsText;
						list[selectRowIndex].groupleaderIds = groupleaderIds;
						list[selectRowIndex].isEdit = true;
					}
					selectRowIndex = -1;
					this.setData({
						list: list
					});
					wx.setStorageSync('select', null);
					break;
				case 'dispatchSubdivision':
					// 细分派工
					this.DispatchSubdivision(select.data);
					wx.setStorageSync('select', null);
					break;
			}
		}

		wx.setStorageSync('workGroupMember', null);
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 搜索框输入事件
	 */
	OnCheckbox: function (e) {
		var i = 0;
		var key = '';
		var checked = e.currentTarget.dataset.checked == "true" || e.currentTarget.dataset.checked ? false : true;
		var list = this.data.list;
		switch (e.currentTarget.dataset.type) {
			case 'all':
				for (i = 0; i < list.length; i++) {
					list[i].checked = checked;
				}
				selectCount = checked ? list.length : 0;
				this.setData({
					allChecked: checked,
					list: list
				});
				break;
			case 'table':
			default:
				list[e.currentTarget.dataset.index].checked = checked;
				checked ? selectCount++ : selectCount--;
				this.setData({
					allChecked: selectCount === list.length,
					list: list
				});
		}
		// 统计
		this.Statistics();
	},

	/**
	 * 表格列点击事件
	 */
	OnTableCol: function (e) {
		var rowindex = parseInt(e.currentTarget.dataset.rowindex);
		var name = e.currentTarget.dataset.name;
		var text = e.currentTarget.dataset.text;
		var type = e.currentTarget.dataset.type;
		var list = this.data.list;
		var tableEdit = this.data.tableEdit;
		if (!isNaN(rowindex) && !util.stringIsNullOrWhiteSpace(name)) {
			list[rowindex].isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
			if (!util.numberIsNullOrEmpty(tableEdit.rowindex) && rowindex !== tableEdit.rowindex) {
				list[tableEdit.rowindex].isfocus = false;
			}
			else {
				list[rowindex].isfocus = true;
			}
			tableEdit.rowindex = rowindex;
			tableEdit.name = name;
			tableEdit.text = text;
			tableEdit.value = list[rowindex][name];
			// 使输入框获得焦点
			tableEdit.focus = true;
			tableEdit.type = function () {
				switch (type) {
					case 'text':
					case 'number':
					case 'idcard':
					case 'digit':
						return type;
					default:
						return 'text';
				}
			}();
			this.setData({
				list: list,
				tableEdit: tableEdit,
				isShowEditModal: true
			});
		}
	},

	/**
	 * 右侧遮罩事件
	 */
	OnRightCover: function (e) {
		this.setData({
			isShowRightCover: e.currentTarget.dataset.type === 'show' ? true : false
		});
	},

	/**
	 * 编辑弹窗事件
	 */
	OnEditModal: function (e) {
		this.setData({
			isShowEditModal: false
		});
	},

	/**
	 * 编辑输入框事件
	 */
	OnEditInput: function (e) {
		inputValue = e.detail.value;
	},

	/**
	 * 确认编辑输入
	 */
	ConfirmEditInput: function () {
		var value = '';
		var list = this.data.list;
		switch (this.data.tableEdit.type) {
			case 'number':
			case 'digit':
				value = parseFloat(inputValue);
				if (isNaN(value) && !util.stringIsNullOrWhiteSpace(inputValue)) {
					return wx.showToast({
						title: '只能输入数字！',
						icon: 'none',
					});
				}
				break;
			default:
				value = inputValue;
		}
		if (list[this.data.tableEdit.rowindex][this.data.tableEdit.name] !== value) {
			list[this.data.tableEdit.rowindex].isEdit = true;
		}
		list[this.data.tableEdit.rowindex][this.data.tableEdit.name] = value;

		// 使输入框失去焦点
		var tableEdit = this.data.tableEdit;
		tableEdit.value = inputValue;
		tableEdit.focus = false;
		this.setData({
			list: list,
			isShowEditModal: false,
			tableEdit: tableEdit
		});
		// 统计
		this.Statistics();
	},

	/**
	 * 选择员工
	 */
	SelectEmployee: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
					duration: 5000
				});
			}
			selectRowIndex = index;
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentEmployee/select/select?type=workGroupLeader'
			});
		}
	},

	/**
	 * 选择工作组
	 */
	SelectWorkGroup: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
					duration: 5000
				});
			}
			selectRowIndex = index;
			if (index === -1) {
				for (var i = 0; i < this.data.list.length; i++) {
					if (this.data.list[i].checked) {
						index = i;
					}
				}
			}
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentWorkGroup/selectWorkGroupAndMembers/select',
				success: res => {
					res.eventChannel.emit('parent', {
						data: this.data.list[index],
						type: 'workGroupLeader'
					});
				}
			});
		}
	},

	/**
	 * 选择组长
	 */
	SelectGroupleader: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
					duration: 5000
				});
			}
			selectRowIndex = index;
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentWorkGroup/select/select'
			});
		}
	},

	/**
	 * 统计
	 */
	Statistics: function() {
		var statistics = this.data.statistics;
		statistics.quantity = 0;
		for (var i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].checked) {
				statistics.quantity += this.data.list[i].quantity;
			}
		}
		this.setData({
			statistics: statistics
		});
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > allList.length ? allList.length : pageIndex * this.data.pageSize;
		var list = [];
		for (start; start < end; start++) {
			list.push(allList[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].quantity = util.floatRound(parseFloat(list[i].quantity), 4);
			list[i].pay = util.floatRound(parseFloat(list[i].pay), 2);
			list[i].workingSeconds = util.floatRound(parseFloat(list[i].workingSeconds), 2);
			list[i].startTime = util.formatDate(util.parseDate(list[i].startTime), 'yyyy/M/d');
			list[i].endTime = util.formatDate(util.parseDate(list[i].endTime), 'yyyy/M/d');
			list[i].createdOn = util.formatDate(util.parseDate(list[i].createdOn), 'yyyy/M/d');
			list[i].confirmTime = util.formatDate(util.parseDate(list[i].confirmTime), 'yyyy/M/d');
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: allList.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/WorkGroupLeaderDispatch/QueryByCurrentGroupleaderForWeb',
			method: 'get',
			data: {
				SearchText: searchText,
				QueryType: 0,
				Status: 15
			},
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
				}
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			pageIndex: 1
		});
		this.Load();
	},

	/**
	 * 检查是否编辑
	 */
	CheckIsEdit: function () {
		for (var i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].isEdit) {	
				wx.showModal({
					title: '',
					content: '有未保存的记录，请保存后在试！',
				});
				return true;
			}
		}
		return false;
	},

	/**
	 * 保存
	 */
	Save: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		var page = this;
		var data = {
			create: [],
			update: [],
			delete: []
		};
		var i = 0;

		// 筛选已编辑行
		for (i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].isEdit) {
				data.update.push(this.data.list[i]);
			}
		}

		if (data.update.length === 0) {
			return wx.showToast({
				title: '没有编辑数据，无需保存！',
				icon: 'none',
				duration: 5000
			});
		}

		this.setData({
			isLoad: true,
			loadText: "正在保存...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkGroupLeaderDispatch/ManualDispatchChange',
			method: 'post',
			data: data,
			success: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '保存成功',
					icon: 'none',
				});
				page.Reload();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 确认
	 */
	Confirm: function (e) {
		if (this.CheckIsEdit() || this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		var page = this;
		var data = {
			updates: []
		};
		var i = 0;

		// 筛选已编辑行
		for (i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].checked) {
				data.updates.push(this.data.list[i]);
			}
		}

		if (data.updates.length === 0) {
			return wx.showToast({
				title: '请勾选要确认的数据！',
				icon: 'none',
				duration: 5000
			});
		}

		this.setData({
			isLoad: true,
			loadText: "正在确认派工...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkGroupLeaderDispatch/ManualDispatchConfirm',
			method: 'post',
			data: data,
			success: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '已确认派工',
					icon: 'none',
				});
				page.Reload();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '提示',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 打开细分派工页面
	 */
	OpenDispatchSubdivisionPage: function (e) {
		var list = this.data.list;
		var checkedCount = 0;
		for (var i = 0; i < list.length; i++) {
			if (list[i].checked) {
				checkedCount++;
			}
		}
		if (checkedCount === 0) {
			return wx.showModal({
				title: '提示',
				content: '请勾选要细分的数据！'
			});
		}
		wx.navigateTo({
			url: '/pages/dispatch/dispatchSubdivision/dispatchSubdivision?type=workGroupLeader',
			success: res => {
				res.eventChannel.emit('parent', {
					type: 'workGroupLeader'
				});
			}
		});
	},

	/**
	 * 细分派工
	 * @param {Array} rows 已选人组 
	 */
	DispatchSubdivision: function (rows) {
		if (util.arrayIsNullOrEmpty(rows) || rows.length === 0) {
			return wx.showToast({
			  title: '您未选择任何个人或工作组！',
			});
		}
		var page = this;
		var data = {
			dispatchIds: [],
			subdivisionObjs: rows
		};
		var list = this.data.list;
		var checkedCount = 0;
		for (var i = 0; i < list.length; i++) {
			if (list[i].checked) {
				checkedCount++;
				data.dispatchIds.push(list[i].id);
			}
		}
		if (checkedCount === 0) {
			return wx.showModal({
				title: '提示',
				content: '请勾选要细分的数据！'
			});
		}
		app.Request({
			url: app.GetDomain() + '/api/WorkGroupLeaderDispatch/ManualDispatchSubdivision',
			method: 'post',
			data: data,
			success: res => {
				wx.showToast({
				  title: '细分派工成功!',
				});
				page.setData({
					isShowRightCover: false
				});
				page.Reload();
			},
			fail: res => {
				wx.showModal({
					title: '提示',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 置空已派人组
	 */
	Clear: function (e) {
		var list = this.data.list;
		var hasChecked = false;
		for (var i = 0; i < list.length; i++) {
			if (list[i].checked) {
				hasChecked = true;
				list[i].isEdit = true;
				list[i].confirmWorkGroupMemberJson = null;
				list[i].workGroupId = null;
				list[i].workGroupName = null;
				list[i].workGroupCode = null;
				list[i].positionId = null;
				list[i].positionName = null;
				list[i].employeeId = null;
				list[i].employeeCode = null;
				list[i].employeeName = null;

				// 置空组长
				// list[i].groupleaderIdsText = null;
				// list[i].groupleaderIds = null;
			}
		}
		if (!hasChecked) {
			return wx.showToast({
				title: '请勾选要置空已派人、组的行！',
				icon: 'none',
				duration: 5000
			});
		}
		this.setData({
			list: list,
			isShowRightCover: false
		});
		wx.showToast({
			title: '已置空勾选的已派人、组的行！',
			icon: 'none',
			duration: 5000
		});
	},

	/**
	 * 合并派工
	 */
	ManualDispatchMerge: function (e) { 
		var page = this;
		var list = this.data.list;
		var data = {
			dispatchIds: []
		};
		var checkedCount = 0;
		for (var i = 0; i < list.length; i++) {
			if (list[i].checked) {
				checkedCount++;
				data.dispatchIds.push(list[i].id);
			}
		}
		if (checkedCount === 0) {
			return wx.showModal({
				title: '提示',
				content: '请勾选要合并派工的数据！'
			});
		}
		wx.showModal({
			content: '确定要合并选中的数据吗？',
			success: function (res) {
				if (!res.confirm) {
					return;
				}
				app.Request({
					url: app.GetDomain() + '/api/WorkGroupLeaderDispatch/ManualDispatchMerge',
					method: 'post',
					data: data,
					success: res => {
						wx.showToast({
						  title: '合并派工成功!',
						});
						page.setData({
							isShowRightCover: false
						});
						page.Reload();
					},
					fail: res => {
						wx.showModal({
							title: '提示',
							content: res.errMsg,
						});
					}
				});
			}
		});
	},
});