const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var url = '';
var parent = {};
var workGroupId = -1;
var inputValue = '';
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		searchInputValue: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		queryType: 10,
		selectedIndex: -1,

		// 是否显示编辑窗口
		isShowEditModal: false,

		// 单元格编辑
		tableEdit: {
			rowindex: null,
			name: null,
			text: '',
			type: 'text',
			focus: false,
			value: ''
		}
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		var page = this;
		workGroupId = options.workGroupId;
		allList = [];
		searchText = '';
		url = '/api/WorkGroupMember/GetWorkGroupMembersByWorkGroupIdForWeb?workGroupId=' + workGroupId;
		parent = {};
		workGroupId = -1;

		var page = this;
		var now = new Date();
		this.setData({
			loadType: 'loading',
			list: []
		});

		var eventChannel = this.getOpenerEventChannel();
		eventChannel.on('parent', res => {
			if (!util.objectIsNullOrEmpty(res)) {
				parent = res;
				if (res.isLoad) {
					page.Load();
				}
				else if (!util.arrayIsNullOrEmpty(res.data) && res.data.length > 0) {
					allList = res.data;
					page.Search();
				}
			}
		});
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var i = 0;
		var list = this.data.list;
		var select = wx.getStorageSync('select');
		var ispush = true;
		if (!util.objectIsNullOrEmpty(select)) {
			switch (select.name) {
				case 'departmentEmployee':
					if (!util.objectIsNullOrEmpty(select.data)) {
						for (var i = 0; i < list.length; i++) {
							if (list[i].employeeId === select.data.employeeId) {
								ispush = false;
							}
						}
						if (ispush) {
							select.data.skill = 0;
							list.push(select.data);
						}
					}
					break;
			}
			this.setData({
				list: list
			});
		}
		wx.setStorageSync('select', null);
	},

	/**
	 * 表格列点击事件
	 */
	OnTableCol: function (e) {
		var rowindex = parseInt(e.currentTarget.dataset.rowindex);
		var name = e.currentTarget.dataset.name;
		var text = e.currentTarget.dataset.text;
		var type = e.currentTarget.dataset.type;
		var list = this.data.list;
		var tableEdit = this.data.tableEdit;
		if (!isNaN(rowindex) && !util.stringIsNullOrWhiteSpace(name)) {
			list[rowindex].isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
			if (!util.numberIsNullOrEmpty(tableEdit.rowindex) && rowindex !== tableEdit.rowindex) {
				list[tableEdit.rowindex].isfocus = false;
			}
			else {
				list[rowindex].isfocus = true;
			}
			tableEdit.rowindex = rowindex;
			tableEdit.name = name;
			tableEdit.text = text;
			tableEdit.value = list[rowindex][name];
			// 使输入框获得焦点
			tableEdit.focus = true;
			tableEdit.type = function () {
				switch (type) {
					case 'text':
					case 'number':
					case 'idcard':
					case 'digit':
						return type;
					default:
						return 'text';
				}
			}();
			this.setData({
				list: list,
				tableEdit: tableEdit,
				isShowEditModal: true
			});
		}
	},

	/**
	 * 编辑弹窗事件
	 */
	OnEditModal: function (e) {
		this.setData({
			isShowEditModal: false
		});
	},

	/**
	 * 编辑输入框事件
	 */
	OnEditInput: function (e) {
		inputValue = e.detail.value;
	},

	/**
	 * 确认编辑输入
	 */
	ConfirmEditInput: function () {
		var value = '';
		var list = this.data.list;
		switch (this.data.tableEdit.type) {
			case 'number':
			case 'digit':
				value = parseFloat(inputValue);
				if (isNaN(value) && !util.stringIsNullOrWhiteSpace(inputValue)) {
					return wx.showToast({
						title: '只能输入数字！',
						icon: 'none',
					});
				}
				break;
			default:
				value = inputValue;
		}
		if (list[this.data.tableEdit.rowindex][this.data.tableEdit.name] !== value) {
			list[this.data.tableEdit.rowindex].isEdit = true;
		}
		list[this.data.tableEdit.rowindex][this.data.tableEdit.name] = value;

		// 使输入框失去焦点
		var tableEdit = this.data.tableEdit;
		tableEdit.value = value;
		tableEdit.focus = false;
		this.setData({
			list: list,
			isShowEditModal: false,
			tableEdit: tableEdit
		});
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 选择行
	 */
	SelectRow: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			this.setData({
				selectedIndex: index
			});
		}
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].skill = parseFloat(list[i].skill) || '';
			list[i].workDays = parseFloat(list[i].workDays) || '';
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + url,
			method: 'get',
			success: res => {
				page.setData({
					isLoad: false
				});
				if (!util.arrayIsNullOrEmpty(res)) {
					allList = res;
					page.Search();
				}
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			list: [],
			pageIndex: 0
		});
		this.Load();
	},

	/**
	 * 返回工作组
	 */
	BackWorkGroup: function () {
		var list = this.data.list;
		var hasWorkDays = false;
		var isSkillChecked = true;
		var isWorkDaysChecked = true;
		for (var i = 0; i < list.length; i++) {
			// 成员比例必须填写
			if (util.numberIsNullOrEmpty(list[i].skill) || list[i].skill === 0) {
				isSkillChecked = false;
			}

			// 判断工作天数是否填写
			if (hasWorkDays && (util.numberIsNullOrEmpty(list[i].workDays) || list[i].workDays === 0)) {
				isWorkDaysChecked = false;
			}
			else if (!util.numberIsNullOrEmpty(list[i].workDays) && list[i].workDays > 0) {
				hasWorkDays = true;
			}
		}
		if (!isSkillChecked) {
			return wx.showToast({
				title: '所选小组中有未编辑的小组成员比例！',
				icon: 'none',
				duration: 5000
			});
		}
		if (!isWorkDaysChecked) {
			return wx.showToast({
				title: '所选小组中如果有填写工作天数，则所有成员都必须填写大于0的工作天数！',
				icon: 'none',
				duration: 5000
			});
		}
		wx.setStorageSync('workGroupMember', {
			name: 'set',
			data: this.data.list
		});
		wx.navigateBack();
	},

	/**
	 * 新增
	 */
	Add: function () {
		wx.navigateTo({
			url: '/pages/departmentEmployee/select/select?type=' + parent.type || '',
		});
	},

	/**
	 * 删除
	 */
	Remove: function () {
		var list = this.data.list;
		if (this.data.selectedIndex > -1) {
			list.splice(this.data.selectedIndex, 1);
		}
		this.setData({
			list: list
		});
	}
})