/**
 * 报工申请
 */
const app = getApp();
const util = require("../../../utils/util");
var selectCount = 0;
var selectRowIndex = -1;
var allList = [];
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		user: {},
		searchText: '',
		searchInputValue: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		query: {
			Status: 10,
			JoinQueryType: 10,
			SearchText: '',
			ModifiedSTime: '',
			ModifiedETime: '',
			StartMdOrderNumber: '',
			EndMdOrderNumber: '',
			Skip: 0,
			Take: 100000
		},

		// 表格是否全选
		allChecked: false,

		// 是否显示右侧菜单
		isShowRightCover: false,

		// 是否显示编辑窗口
		isShowEditModal: false,

		// 单元格编辑
		tableEdit: {
			rowindex: null,
			name: null,
			text: '',
			type: 'text',
			focus: false,
			value: ''
		}
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		selectCount = 0;
		selectRowIndex = -1;
		var page = this;
		var now = new Date();
		var tableEdit = this.data.tableEdit;
		tableEdit.focus = false;
		this.setData({
			loadType: 'loading',
			list: [],
			pageIndex: 0,
			today: util.formatDate(now, "yyyy-MM-dd"),
			confirmSTime: util.formatDate(util.parseDate(now.getFullYear() + '-' + (now.getMonth() + 1) + "-1"), "yyyy-MM-dd"),
			confirmETime: util.formatDate(now, "yyyy-MM-dd"),
			tableEdit: tableEdit
		});
		page.Load();
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var i = 0;
		var list = this.data.list;
		var select = wx.getStorageSync('select');
		if (!util.objectIsNullOrEmpty(select)) {
			switch (select.name) {
				case 'departmentEmployee':
					// 填写员工
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].confirmEmployeeId = select.data.employeeId || '';
								list[i].confirmEmployeeName = select.data.employeeName || '';
								list[i].confirmEmployeeCode = select.data.employeeCode || '';
								list[i].positionId = select.data.positionId || '';
								list[i].positionName = select.data.positionName || '';
								list[i].isEdit = true;

								// 清空小组
								list[i].members = null;
								list[i].confirmWorkGroupId = null;
								list[i].confirmWorkGroupName = null;
								list[i].confirmWorkGroupCode = null;
							}
						}
					}
					else if (selectRowIndex > -1) {
						list[selectRowIndex].confirmEmployeeId = select.data.employeeId || '';
						list[selectRowIndex].confirmEmployeeName = select.data.employeeName || '';
						list[selectRowIndex].confirmEmployeeCode = select.data.employeeCode || '';
						list[selectRowIndex].positionId = select.data.positionId || '';
						list[selectRowIndex].positionName = select.data.positionName || '';
						list[selectRowIndex].isEdit = true;

						// 清空小组
						list[selectRowIndex].members = null;
						list[selectRowIndex].confirmWorkGroupId = null;
						list[selectRowIndex].confirmWorkGroupName = null;
						list[selectRowIndex].confirmWorkGroupCode = null;
					}
					selectRowIndex = -1;
					this.setData({
						list: list
					});
					break;
				case 'departmentWorkGroupAndMembers':
					// 填写工作组和工作组成员
					// 多选
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].confirmWorkGroupId = select.data.workGroupId;
								list[i].confirmWorkGroupName = select.data.workGroupName;
								list[i].members = JSON.parse(select.data.confirmWorkGroupMemberJson);
								list[i].isEdit = true;

								// 清空员工、员工岗位
								list[i].positionId = null;
								list[i].positionName = null;
								list[i].confirmEmployeeId = null;
								list[i].confirmEmployeeCode = null;
								list[i].confirmEmployeeName = null;
							}
						}
					}
					// 单选
					else if (selectRowIndex > -1) {
						list[selectRowIndex].confirmWorkGroupId = select.data.workGroupId;
						list[selectRowIndex].confirmWorkGroupName = select.data.workGroupName;
						list[selectRowIndex].members = JSON.parse(select.data.confirmWorkGroupMemberJson);
						list[selectRowIndex].isEdit = true;

						// 清空员工、员工岗位
						list[selectRowIndex].positionId = null;
						list[selectRowIndex].positionName = null;
						list[selectRowIndex].confirmEmployeeId = null;
						list[selectRowIndex].confirmEmployeeCode = null;
						list[selectRowIndex].confirmEmployeeName = null;
					}
					selectRowIndex = -1;
					this.setData({
						list: list
					});
					break;
				case 'dispatch':
					// 新增派工
					var list = [];
					for (i = 0; i < select.data.length; i++) {
						list.push(select.data[i].id);
					}
					this.Create(list);
					this.setData({
						isShowRightCover: false
					});
					break;
			}
		}

		wx.setStorageSync('select', null);
		wx.setStorageSync('workGroupMember', null);
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 输入框事件
	 */
	OnInput: function (e) {
		var query = this.data.query;
		query[e.currentTarget.dataset.name] = e.detail.value;
		this.setData({
			query: query
		});
	},

	/**
	 * 搜索框输入事件
	 */
	OnCheckbox: function (e) {
		var i = 0;
		var key = '';
		var checked = e.currentTarget.dataset.checked == "true" || e.currentTarget.dataset.checked ? false : true;
		var list = this.data.list;
		switch (e.currentTarget.dataset.type) {
			case 'all':
				for (i = 0; i < list.length; i++) {
					list[i].checked = checked;
				}
				selectCount = checked ? list.length : 0;
				this.setData({
					allChecked: checked,
					list: list
				});
				break;
			case 'table':
			default:
				list[e.currentTarget.dataset.index].checked = checked;
				checked ? selectCount++ : selectCount--;
				this.setData({
					allChecked: selectCount === list.length,
					list: list
				});
		}
	},

	/**
	 * 表格列点击事件
	 */
	OnTableCol: function (e) {
		var rowindex = parseInt(e.currentTarget.dataset.rowindex);
		var name = e.currentTarget.dataset.name;
		var text = e.currentTarget.dataset.text;
		var type = e.currentTarget.dataset.type;
		var list = this.data.list;
		var tableEdit = this.data.tableEdit;
		if (!isNaN(rowindex) && !util.stringIsNullOrWhiteSpace(name)) {
			list[rowindex].isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
			if (!util.numberIsNullOrEmpty(tableEdit.rowindex) && rowindex !== tableEdit.rowindex) {
				list[tableEdit.rowindex].isfocus = false;
			}
			else {
				list[rowindex].isfocus = true;
			}
			tableEdit.rowindex = rowindex;
			tableEdit.name = name;
			tableEdit.text = text;
			tableEdit.value = list[rowindex][name];
			// 使输入框获得焦点
			tableEdit.focus = true;
			tableEdit.type = function () {
				switch (type) {
					case 'text':
					case 'number':
					case 'idcard':
					case 'digit':
						return type;
					default:
						return 'text';
				}
			}();
			this.setData({
				list: list,
				tableEdit: tableEdit,
				isShowEditModal: true
			});
		}
	},

	/**
	 * 右侧遮罩事件
	 */
	OnRightCover: function (e) {
		this.setData({
			isShowRightCover: e.currentTarget.dataset.type === 'show' ? true : false
		});
	},

	/**
	 * 编辑弹窗事件
	 */
	OnEditModal: function (e) {
		this.setData({
			isShowEditModal: false
		});
	},

	/**
	 * 编辑输入框事件
	 */
	OnEditInput: function (e) {
		var tableEdit = this.data.tableEdit;
		tableEdit.value = e.detail.value;
		this.setData({
			tableEdit: tableEdit
		});
	},

	/**
	 * 确认编辑输入
	 */
	ConfirmEditInput: function () {
		var value = '';
		var list = this.data.list;
		switch (this.data.tableEdit.type) {
			case 'number':
			case 'digit':
				value = parseFloat(this.data.tableEdit.value);
				if (isNaN(value)) {
					return wx.showToast({
						title: '只能输入数字！',
						icon: 'none',
					});
				}
				break;
			default:
				value = this.data.tableEdit.value;
		}
		if (list[this.data.tableEdit.rowindex][this.data.tableEdit.name] !== value) {
			list[this.data.tableEdit.rowindex].isEdit = true;
		}
		list[this.data.tableEdit.rowindex][this.data.tableEdit.name] = value;

		// 使输入框失去焦点
		var tableEdit = this.data.tableEdit;
		tableEdit.focus = false;
		this.setData({
			list: list,
			isShowEditModal: false,
			tableEdit: tableEdit
		});
	},

	/**
	 * 选择员工
	 */
	SelectEmployee: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
				});
			}
			selectRowIndex = index;
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentEmployee/select/select?url=/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkshopSupervisorLeaderForWeb'
			});
		}
	},

	/**
	 * 选择工作组
	 */
	SelectWorkGroup: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
				});
			}
			selectRowIndex = index;
			if (index === -1) {
				for (var i = 0; i < this.data.list.length; i++) {
					if (this.data.list[i].checked) {
						index = i;
					}
				}
			}
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentWorkGroup/selectWorkGroupAndMembers/select',
				success: res => {
					res.eventChannel.emit('parent', {
						data: this.data.list[index],
						getEmployeeUrl: '/api/DepartmentEmployee/GetDepartmentEmployeeFullInfoByWorkshopSupervisorLeaderForWeb',
						type: 'workOrderApplication'
					});
				}
			});
		}
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > allList.length ? allList.length : pageIndex * this.data.pageSize;
		var list = [];
		for (start; start < end; start++) {
			list.push(allList[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].quantity = util.floatRound(parseFloat(list[i].quantity), 4);
			list[i].confirmQuantity = util.floatRound(parseFloat(list[i].confirmQuantity), 4);
			list[i].pay = util.floatRound(parseFloat(list[i].pay), 2);
			list[i].workingSeconds = util.floatRound(parseFloat(list[i].workingSeconds), 2);
			list[i].startTime = util.formatDate(util.parseDate(list[i].startTime), 'yyyy/M/d');
			list[i].endTime = util.formatDate(util.parseDate(list[i].endTime), 'yyyy/M/d');
			list[i].createdOn = util.formatDate(util.parseDate(list[i].createdOn), 'yyyy/M/d');
			list[i].lastModifiedOn = util.formatDate(util.parseDate(list[i].lastModifiedOn), 'yyyy/M/d');
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: allList.length,
			isLoad: false,
			allChecked: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		allList = [];
		searchText = '';
		var page = this;
		var query = this.data.query;
		query.SearchText = searchText;
		app.Request({
			url: app.GetDomain() + '/api/WorkOrderApplication/GetMoreInfoPagedAllForWeb',
			method: 'get',
			data: query,
			success: res => {
				if (!util.arrayIsNullOrEmpty(res.items)) {
					allList = res.items;
				}
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			pageIndex: 1
		});
		this.Load();
	},

	/**
	 * 新增
	 */
	Add: function (e) {
		this.setData({
			isShowRightCover: false
		});
		wx.navigateTo({
			url: '/pages/dispatch/select/select',
		});
	},

	/**
	 * 保存
	 */
	Save: function () {
		this.Execute('save');
	},

	/**
	 * 删除
	 */
	Delete: function () {
		this.Execute('delete');
	},

	/**
	 * 执行
	 */
	Execute: function (type) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		var page = this;
		var list = [];
		var errMsg = '';
		var data = {
			inserts: [],
			updates: [],
			deletes: []
		};
		var i = 0;

		// 筛选已编辑行
		for (i = 0; i < this.data.list.length; i++) {
			if ((type === 'save' && this.data.list[i].isEdit) || type === 'delete' && this.data.list[i].checked) {
				list.push(this.data.list[i]);
			}
		}

		// 删除多余属性
		for (i = 0; i < list.length; i++) {
			delete list[i].isEdit;
			delete list[i].isfocus;
			delete list[i].checked;
		}

		switch(type){
			case 'save':
				data.updates = list;
				errMsg = '没有编辑数据，无需保存！';
				break;
			case 'delete':
				data.deletes = list;
				errMsg = '请勾选要删除的数据！';
				break;
			default:
				return;
		}

		if (list.length === 0) {
			return wx.showToast({
				title: errMsg,
				icon: 'none',
				duration: 5000
			});
		}

		this.setData({
			isLoad: true,
			loadText: "正在保存...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkOrderApplication/Merge',
			method: 'post',
			data: data,
			success: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '保存成功',
					icon: 'none',
				});
				page.Reload();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 报工确认
	 */
	Confirm: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		var page = this;
		var data = {
			ids: []
		};
		var i = 0;

		// 筛选已编辑行
		for (i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].checked) {
				data.ids.push(this.data.list[i].id);
			}
		}

		if (data.ids.length === 0) {
			return wx.showToast({
				title: '请勾选要确认的数据！',
				icon: 'none',
				duration: 5000
			});
		}

		this.setData({
			isLoad: true,
			loadText: "正在确认报工...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkOrderApplication/Confirm',
			method: 'post',
			data: data,
			success: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '已确认报工',
					icon: 'none',
				});
				page.Reload();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 置空已报人组
	 */
	Clear: function (e) {
		var list = this.data.list;
		var hasChecked = false;
		for (var i = 0; i < list.length; i++) {
			if (list[i].checked) {
				hasChecked = true;
				list[i].employeeId = null;
				list[i].employeeCode = '';
				list[i].employeeName = '';
				list[i].positionId = null;
				list[i].positionName = '';
				list[i].workGroupId = null;
				list[i].workGroupName = '';
				list[i].confirmWorkGroupMemberJson = '';
			}
		}
		if (!hasChecked) {
			return wx.showToast({
				title: '请勾选要置空已报人、组的行！',
				icon: 'none',
				duration: 5000
			});
		}
		this.setData({
			list: list,
			isShowRightCover: false
		});
		wx.showToast({
			title: '已置空勾选的已报人、组的行！',
			icon: 'none',
			duration: 5000
		});
	},

	/**
	 * 创建报工
	 */
	Create: function(list) {
		if (this.data.isLoad || this.data.loadType === 'over' || util.arrayIsNullOrEmpty(list)) {
			return false;
		}
		var page = this;
		this.setData({
			isLoad: true,
			loadText: "正在创建报工...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkOrderApplication/CreateByDispatchIds',
			method: 'post',
			data: {
				ids: list
			},
			success: function (res) {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '已创建报工',
					icon: 'none',
				});
				page.Reload();
			},
			fail: function (res) {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	}
});