/**
 * 按小工序派工
 */
const app = getApp();
const util = require("../../../utils/util");
var allList = [];
var selectCount = 0;
var selectRowIndex = -1;
var searchText = '';

Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		StatusBar: app.globalData.StatusBar,
		CustomBar: app.globalData.CustomBar,
		Custom: app.globalData.Custom,
		searchText: '',
		pageIndex: 0,
		pageSize: 500,
		rowsCount: 0,
		list: [],
		isLoad: false,
		loadType: "loading",
		loadText: "加载中...",
		selectedIndex: 0,
		queryType: 10,

		// 表格是否全选
		allChecked: false,

		// 是否显示编辑窗口
		isShowEditModal: false,

		// 单元格编辑
		tableEdit: {
			rowindex: null,
			name: null,
			text: '',
			type: 'text',
			focus: false,
			value: ''
		}
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function () {
		selectCount = 0;
		selectRowIndex = -1;
		var now = new Date();
		var tableEdit = this.data.tableEdit;
		tableEdit.focus = false;
		allList = [];
		searchText = '';
		this.setData({
			loadType: 'loading',
			list: [],
			pageIndex: 0,
			today: util.formatDate(now, "yyyy-MM-dd"),
			tableEdit: tableEdit,
			allChecked: false
		});
		this.Load();
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow: function () {
		var i = 0;
		var j = 0;
		var list = this.data.list;
		var select = wx.getStorageSync('select');
		if (!util.objectIsNullOrEmpty(select)) {
			switch (select.name) {
				case 'departmentWorkGroup':
					// 填写组长
					var groupleaderIdsText = '';
					var groupleaderIds = '';
					for (i = 0; i < select.data.length; i++) {
						groupleaderIdsText += (i > 0 ? ',' : '') + select.data[i].workGroupLeaderName;
						groupleaderIds += (i > 0 ? ',' : '') + select.data[i].workGroupLeaderId;
					}
					// 多选
					if (selectRowIndex === -1) {
						for (i = 0; i < list.length; i++) {
							if (list[i].checked) {
								list[i].groupleaderIdsText = groupleaderIdsText;
								list[i].groupleaderIds = groupleaderIds;
								list[i].isEdit = true;
							}
						}
					}
					// 单选
					else if (selectRowIndex > -1) {
						list[selectRowIndex].groupleaderIdsText = groupleaderIdsText;
						list[selectRowIndex].groupleaderIds = groupleaderIds;
						list[selectRowIndex].isEdit = true;
					}

					selectRowIndex = -1;
					this.setData({
						list: list
					});
					wx.setStorageSync('select', null);
					break;
			}
		}
	},

	/**
	 * 搜索框输入事件
	 */
	OnCheckbox: function (e) {
		var i = 0;
		var key = '';
		var checked = e.currentTarget.dataset.checked == "true" || e.currentTarget.dataset.checked ? false : true;
		var list = this.data.list;
		switch (e.currentTarget.dataset.type) {
			case 'all':
				for (i = 0; i < list.length; i++) {
					list[i].checked = checked;
				}
				selectCount = checked ? list.length : 0;
				this.setData({
					allChecked: checked,
					list: list
				});
				break;
			case 'table':
			default:
				list[e.currentTarget.dataset.index].checked = checked;
				checked ? selectCount++ : selectCount--;
				this.setData({
					allChecked: selectCount === list.length,
					list: list
				});
		}
	},

	/**
	 * 改变查询类型
	 */
	ChangeQueryType: function (e) {
		var queryType = parseInt(e.currentTarget.dataset.type);
		if (!isNaN(queryType)) {
			this.setData({
				queryType: queryType
			});
			this.Reload();
		}
	},

	/**
	 * 搜索框输入事件
	 */
	OnSearchInput: function (e) {
		searchText = e.detail.value
	},

	/**
	 * 清除查询
	 */
	ClearSearchInput: function () {
		this.setData({
			searchText: ''
		});
		searchText = '';
		this.Search();
	},

	/**
	 * 表格列点击事件
	 */
	OnTableCol: function (e) {
		var rowindex = parseInt(e.currentTarget.dataset.rowindex);
		var name = e.currentTarget.dataset.name;
		var text = e.currentTarget.dataset.text;
		var type = e.currentTarget.dataset.type;
		var list = this.data.list;
		var tableEdit = this.data.tableEdit;
		if (!isNaN(rowindex) && !util.stringIsNullOrWhiteSpace(name)) {
			list[rowindex].isfocus = e.currentTarget.dataset.isfocus === 'true' ? false : true;
			if (!util.numberIsNullOrEmpty(tableEdit.rowindex) && rowindex !== tableEdit.rowindex) {
				list[tableEdit.rowindex].isfocus = false;
			} else {
				list[rowindex].isfocus = true;
			}
			tableEdit.rowindex = rowindex;
			tableEdit.name = name;
			tableEdit.text = text;
			tableEdit.value = list[rowindex][name];
			// 使输入框获得焦点
			tableEdit.focus = true;
			tableEdit.type = function () {
				switch (type) {
					case 'text':
					case 'number':
					case 'idcard':
					case 'digit':
						return type;
					default:
						return 'text';
				}
			}();
			this.setData({
				list: list,
				tableEdit: tableEdit,
				isShowEditModal: true
			});
		}
	},

	/**
	 * 编辑弹窗事件
	 */
	OnEditModal: function (e) {
		this.setData({
			isShowEditModal: false
		});
	},

	/**
	 * 编辑输入框事件
	 */
	OnEditInput: function (e) {
		var tableEdit = this.data.tableEdit;
		tableEdit.value = e.detail.value;
		this.setData({
			tableEdit: tableEdit
		});
	},

	/**
	 * 确认编辑输入
	 */
	ConfirmEditInput: function () {
		var value = '';
		var list = this.data.list;
		switch (this.data.tableEdit.type) {
			case 'number':
			case 'digit':
				value = parseFloat(this.data.tableEdit.value);
				if (isNaN(value)) {
					return wx.showToast({
						title: '只能输入数字！',
						icon: 'none',
					});
				}
				break;
			default:
				value = this.data.tableEdit.value;
		}
		if (list[this.data.tableEdit.rowindex][this.data.tableEdit.name] !== value) {
			list[this.data.tableEdit.rowindex].isEdit = true;
		}
		list[this.data.tableEdit.rowindex][this.data.tableEdit.name] = value;

		// 使输入框失去焦点
		var tableEdit = this.data.tableEdit;
		tableEdit.focus = false;
		this.setData({
			list: list,
			isShowEditModal: false,
			tableEdit: tableEdit
		});
	},

	/**
	 * 跳页
	 * @param {object} e 事件对象 
	 */
	GotoPage: function (e) {
		var pageIndex = parseInt(e.currentTarget.dataset.pageindex);
		if (isNaN(pageIndex)) {
			return;
		}
		this.Search(pageIndex);
	},

	/**
	 * 查询
	 * @param {number} pageIndex 
	 */
	Search: function (pageIndex) {
		pageIndex = util.numberIsNullOrEmpty(pageIndex) ? 1 : pageIndex < 1 ? 1 : pageIndex;
		// 分页后的数据
		var list = [];
		// 筛选后的数据
		var slist = [];
		if (!util.stringIsNullOrWhiteSpace(searchText)) {
			for (var i = 0; i < allList.length; i++) {
				for (var name in allList[i]) {
					if (!util.objectIsNullOrEmpty(allList[i][name]) && allList[i][name].toString().indexOf(searchText) >= 0) {
						slist.push(allList[i]);
						break;
					}
				}
			}
		}
		else {
			slist = allList;
		}
		var start = (pageIndex - 1) * this.data.pageSize;
		var end = pageIndex * this.data.pageSize > slist.length ? slist.length : pageIndex * this.data.pageSize;
		for (start; start < end; start++) {
			list.push(slist[start]);
		}
		for (var i = 0; i < list.length; i++) {
			list[i].quantity = parseFloat(list[i].quantity) || 0;
			list[i].dispatchedQty = parseFloat(list[i].dispatchedQty) || 0;
			list[i].dispatchedInputQty = list[i].quantity - list[i].dispatchedQty;
			list[i].payText = util.formatAmount(parseFloat(list[i].pay), 4);
			list[i].workingSecondsText = util.formatAmount(parseFloat(list[i].workingSeconds), 1);
		}
		this.setData({
			list: list,
			pageIndex: pageIndex,
			rowsCount: slist.length,
			isLoad: false
		});
	},

	/**
	 * 加载数据
	 */
	Load: function (e) {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		this.setData({
			isLoad: true,
			loadText: "加载中...",
		});
		var page = this;
		app.Request({
			url: app.GetDomain() + '/api/WorkshopSupervisorDispatch/GetNoDisptchProcessByCurrentWorkshopSupervisorForWeb',
			method: 'post',
			data: {
				status: null,
				orderIds: []
			},
			success: res => {
				allList = util.arrayIsNullOrEmpty(res.infos) ? [] : res.infos;
				page.Search();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},

	/**
	 * 重新加载
	 */
	Reload: function (e) {
		this.setData({
			pageIndex: 1
		});
		this.Load();
	},

	/**
	 * 选择组长
	 */
	SelectGroupleader: function (e) {
		var index = parseInt(e.currentTarget.dataset.index);
		if (!isNaN(index)) {
			if (index === -1 && selectCount === 0) {
				return wx.showToast({
					title: '请勾选要批量操作的行',
					icon: 'none',
					duration: 5000
				});
			}
			selectRowIndex = index;
			this.setData({
				isShowRightCover: false
			});
			wx.navigateTo({
				url: '/pages/departmentWorkGroup/select/select'
			});
		}
	},

	/**
	 * 生成派工
	 */
	CreateManualDispatch: function () {
		if (this.data.isLoad || this.data.loadType === 'over') {
			return false;
		}
		var page = this;
		var data = {
			manualDispatchType: 20,
			manualDispatchCreates: []
		};
		var i = 0;

		// 筛选已编辑行
		for (i = 0; i < this.data.list.length; i++) {
			if (this.data.list[i].checked) {
				data.manualDispatchCreates.push({
					orderProcessId: this.data.list[i].id,
					quantity: this.data.list[i].dispatchedInputQty,
					groupLeader: null,
					employeeId: null,
					workGroupId: null,
					groupLeaderIds: this.data.list[i].groupleaderIds
				});
			}
		}

		if (data.manualDispatchCreates.length === 0) {
			return wx.showToast({
				title: '请勾选要生成派工的数据！',
				icon: 'none',
				duration: 5000
			});
		}

		this.setData({
			isLoad: true,
			loadText: "正在生成派工...",
			isShowRightCover: false
		});
		app.Request({
			url: app.GetDomain() + '/api/WorkshopSupervisorDispatch/ManualDispatchCreate',
			method: 'post',
			data: data,
			success: res => {
				page.setData({
					isLoad: false
				});
				wx.showToast({
					title: '已生成派工',
					icon: 'none',
				});
				// wx.navigateTo({
				// 	url: '/pages/workshopSupervisorDispatch/index/index',
				// });
				wx.navigateBack();
			},
			fail: res => {
				page.setData({
					isLoad: false,
					loadType: 'erro'
				});
				wx.showModal({
					title: '',
					content: res.errMsg,
				});
			}
		});
	},
});